﻿
Imports System.IO 'needed for read and write files; if problems, maybe needs to be in form file

Module Declarations

    'Quantities
    'Public Const BACKGROUND_IMAGE_PATH = 

    Public Const TURN_INTERVAL As Integer = 20
    Public Const DATE_LBL_BASE As String = " YEARS: "

    Public Const WHEN_SHOW_CONTROLS As Integer = 6 'allow more than Attack after 6th action

    Public Const SPACER_STR As String = "-----------------------------------------------" & vbCrLf

    Public Const NONE As Integer = 0
    Public Const LIMITED As Integer = 1
    Public Const EXTENSIVE As Integer = 2

    Public Const SLASH_AND_BURN As Integer = 0
    Public Const TWO_FIELD As Integer = 1
    Public Const THREE_FIELD As Integer = 2
    Public Const DIVERSIFIED As Integer = 4
    Public Const MECHANIZED As Integer = 8

    Public Const WATER As Integer = 0
    Public Const LAND As Integer = 1

    Public Const OCEAN As Integer = -2
    Public Const COASTAL As Integer = -1
    Public Const FLATLAND As Integer = 0
    Public Const RUGGED As Integer = 1
    Public Const MOUNTAINS As Integer = 2

    Public Const OCEAN_STR As String = "Ocean"
    Public Const COASTAL_STR As String = "Coastal"
    Public Const FLATLAND_STR As String = "Field & Forest"
    Public Const RUGGED_STR As String = "Difficult"
    Public Const MOUNTAINS_STR As String = "Mountainous"

    Public Const NO_SELECTION = -1
    Public Const SEALANE As Integer = 0
    Public Const RIVER As Integer = 1
    Public Const ROADS As Integer = 2

    Public OCEAN_COLOR As System.Drawing.Color = Color.CadetBlue
    Public COASTAL_COLOR As System.Drawing.Color = Color.PowderBlue
    Public FLATLAND_COLOR As System.Drawing.Color = Color.PaleGreen
    Public RUGGED_COLOR As System.Drawing.Color = Color.Khaki
    Public MOUNTAIN_COLOR As System.Drawing.Color = Color.Peru

    Public OCEAN_CONNECTOR_COLOR As System.Drawing.Color = Color.CadetBlue
    Public COASTAL_CONNECTOR_COLOR As System.Drawing.Color = Color.PowderBlue
    Public RIVER_CONNECTOR_COLOR As System.Drawing.Color = Color.Blue
    Public ROAD_CONNECTOR_COLOR As System.Drawing.Color = Color.Chocolate

    Public Const MAX_NEIGHBORS_LAND As Integer = 6
    Public Const MAX_NEIGHBORS_SEA As Integer = 17

    Public Const COMMA As String = ","
    Public Const DOUBLE_SPACE As String = vbCrLf & vbCrLf

    'New or Saved Game to be Played (and files therefore loaded)
    Public Const NEW_GAME As Integer = 0
    Public Const SAVED_GAME As Integer = 1

    Public Const CLOVIS_SCENARIO_FOLDER As String = "\ClovisScenario"
    Public Const CAPETIAN_SCENARIO_FOLDER As String = "\CapetianScenario"

    Public ScenarioFolder As String = CAPETIAN_SCENARIO_FOLDER
    'Public ScenarioFolder As String = CLOVIS_SCENARIO_FOLDER

    Public AREAS_AT_START_FILENAME As String = ScenarioFolder & "\AreasAtStart.txt"
    Public PROVINCES_AT_START_FILENAME As String = ScenarioFolder & "\ProvincesAtStart.txt"
    Public SEAS_AT_START_FILENAME As String = ScenarioFolder & "\SeasAtStart.txt"
    Public CONNECTORS_AT_START_FILENAME As String = ScenarioFolder & "\ConnectorsAtStart.txt"
    Public GOVERNMENTS_AT_START_FILENAME As String = ScenarioFolder & "\GovernmentsAtStart.txt"
    Public GLOBALS_AT_START_FILENAME As String = ScenarioFolder & "\GlobalsAtStart.txt"

    'Public Const SAVED_AREAS_FILENAME As String = "\SavedAreas.txt" ' don't need this
    Public Const SAVED_PROVINCES_FILENAME As String = "\SavedProvinces.txt"
    Public Const SAVED_SEAS_FILENAME As String = "\SavedSeas.txt"
    Public Const SAVED_CONNECTORS_FILENAME As String = "\SavedConnectors.txt"
    Public Const SAVED_GOVERNMENTS_FILENAME As String = "\SavedGovernments.txt"
    Public Const SAVED_GLOBALS_FILENAME As String = "\SavedGlobals.txt"

    Public Const AUTO_SAVED_PROVINCES_FILENAME As String = "_AS_Prov_"
    Public Const AUTO_SAVED_GOVERNMENTS_FILENAME As String = "_AS_Govs_"
    Public Const AUTO_SAVED_GLOBALS_FILENAME As String = "_AS_Glob_"
    Public Const AUTO_SAVED_END_FILENAME As String = "_AS_End_"

    Public Const PLAYER_SAVE As String = "NoDateTime"
    Public Const AUTO_SAVE_PLACE As String = "\Autosaves\"

    Public Const CLIMATE_ZONES As Integer = 11
    Public Const TERRIBLE_WEATHER As Integer = -2
    Public Const BAD_WEATHER As Integer = -1
    Public Const GOOD_WEATHER As Integer = 1
    Public Const GREAT_WEATHER As Integer = 2
    Public Const NORMAL_WEATHER As Integer = 0

    Public Const TERRIBLE_WEATHER_STR As String = "Terrible"
    Public Const BAD_WEATHER_STR As String = "Bad"
    Public Const GOOD_WEATHER_STR As String = "Good"
    Public Const GREAT_WEATHER_STR As String = "Great"
    Public Const NORMAL_WEATHER_STR As String = "Normal"

    Public TERRIBLE_WEATHER_COLOR As System.Drawing.Color = Color.DarkGray
    Public BAD_WEATHER_COLOR As System.Drawing.Color = Color.LightGray
    Public NORMAL_WEATHER_COLOR As System.Drawing.Color = Color.AliceBlue
    Public GOOD_WEATHER_COLOR As System.Drawing.Color = Color.LemonChiffon
    Public GREAT_WEATHER_COLOR As System.Drawing.Color = Color.Yellow

    Public Const CLIMATE_ZONE_1_STR = "N.W. Interior"
    Public Const CLIMATE_ZONE_2_STR = "N.W. Coast"
    Public Const CLIMATE_ZONE_3_STR = "N.W. Mediterranean"
    Public Const CLIMATE_ZONE_4_STR = "S. Mediterranean."
    Public Const CLIMATE_ZONE_5_STR = "Alpine"
    Public Const CLIMATE_ZONE_6_STR = "N.E. Europe"
    Public Const CLIMATE_ZONE_7_STR = "S.E. Europe"
    Public Const CLIMATE_ZONE_8_STR = "E. Mediterranean"
    Public Const CLIMATE_ZONE_9_STR = "Russia"
    Public Const CLIMATE_ZONE_10_STR = "W. Coast"
    Public Const CLIMATE_ZONE_0_STR = "Extra-European"

    'Social States
    Public Const CHAOS As Integer = -2
    Public Const DISORDER As Integer = -1
    Public Const ORDERLY As Integer = 0
    Public Const PROSPEROUS As Integer = 1
    Public Const BOOMING As Integer = 2

    Public Const CHAOS_STR As String = "Chaotic"
    Public Const DISORDER_STR As String = "Disorderly"
    Public Const ORDERLY_STR As String = "Orderly"
    Public Const PROSPEROUS_STR As String = "Comfortable"
    Public Const BOOMING_STR As String = "Thriving"

    Public CHAOS_COLOR As System.Drawing.Color = Color.Red
    Public DISORDER_COLOR As System.Drawing.Color = Color.LightCoral
    Public ORDERLY_COLOR As System.Drawing.Color = Color.Beige
    Public PROSPEROUS_COLOR As System.Drawing.Color = Color.Chartreuse
    Public BOOMING_COLOR As System.Drawing.Color = Color.Gold

    'Provincial Loyalties and Political Support
    Public Const REBELLIOUS As Integer = -2
    Public Const DISENCHANTED As Integer = -1
    Public Const INDIFFERENT As Integer = 0
    Public Const SUPPORTIVE As Integer = 1
    Public Const ENTHUSIASTIC As Integer = 2

    Public Const REBELLIOUS_STR As String = "Rebellious"
    Public Const DISENCHANTED_STR As String = "Disenchanted"
    Public Const INDIFFERENT_STR As String = "Indifferent"
    Public Const SUPPORTIVE_STR As String = "Supportive"
    Public Const ENTHUSIASTIC_STR As String = "Dedicated"

    Public REBELLIOUS_COLOR As System.Drawing.Color = Color.Red
    Public DISENCHANTED_COLOR As System.Drawing.Color = Color.LightCoral
    Public INDIFFERENT_COLOR As System.Drawing.Color = Color.Beige
    Public SUPPORTIVE_COLOR As System.Drawing.Color = Color.Chartreuse
    Public ENTHUSIASTIC_COLOR As System.Drawing.Color = Color.Gold

    ' Religions
    Public Const NO_RELIGION As Integer = -1
    Public Const PAGAN As Integer = 0
    Public Const CHRISTIAN_LOWER_BOUND As Integer = 100
    Public Const CATHOLIC As Integer = 101
    Public Const ARIAN As Integer = 102
    Public Const ORTHADOX As Integer = 103
    Public Const WALDENSIAN As Integer = 104
    Public Const PROTESTANT As Integer = 106
    Public Const CHRISTIAN_UPPER_BOUND As Integer = 110
    Public Const MUSLIM As Integer = 130
    Public Const ALBEGENSIAN As Integer = 200

    Public Const MAX_CHRISTIAN_SECTS As Integer = 9
    Public Const MONTHEISTIC_RANGE As Integer = 49

    Public Const PAGAN_STR As String = "Pagan"
    Public Const CATHOLIC_STR As String = "Catholic"
    Public Const ARIAN_STR As String = "Arian"
    Public Const ORTHADOX_STR As String = "Orthadox"
    Public Const MUSLIM_STR As String = "Muslim"
    Public Const WALDENSIAN_STR As String = "Waldensian"
    Public Const ALBEGENSIAN_STR As String = "Albegensian"
    Public Const PROTESTANT_STR As String = "Protestant"

    Public PAGAN_COLOR As System.Drawing.Color = Color.RosyBrown
    Public CATHOLIC_COLOR As System.Drawing.Color = Color.Beige
    Public ARIAN_COLOR As System.Drawing.Color = Color.MistyRose
    Public ORTHADOX_COLOR As System.Drawing.Color = Color.Thistle
    Public MUSLIM_COLOR As System.Drawing.Color = Color.LimeGreen
    Public WALDENSIAN_COLOR As System.Drawing.Color = Color.SandyBrown
    Public ALBEGENSIAN_COLOR As System.Drawing.Color = Color.Wheat
    Public PROTESTANT_COLOR As System.Drawing.Color = Color.Turquoise

    ' Languages
    Public Const NO_LANGUAGE As Integer = -1
    Public Const LOCAL_LANGUAGE As Integer = 0
    'Public Const ROMANCE As Integer = 100
    'Public Const LOCAL_ROMANCE As Integer = 101
    Public Const FRENCH As Integer = 110
    'Public Const LOCAL_FRENCH As Integer = 111
    Public Const LANGUEDOC As Integer = 112
    Public Const LANGUEDOIL As Integer = 113
    'Public Const IBERIAN As Integer = 120
    Public Const LOCAL_IBERIAN As Integer = 121
    'Public Const ITALIAN As Integer = 130
    Public Const LOCAL_ITALIAN As Integer = 131
    'Public Const VLACH As Integer = 141
    Public Const GERMANIC As Integer = 200
    Public Const LOCAL_GERMANIC As Integer = 201
    'Public Const OLD_HIGH_GERMAN As Integer = 210
    'Public Const OLD_SAXON As Integer = 210
    'Public Const LOW_FRANKISH As Integer = 210
    'Public Const OLD_NORSE As Integer = 210
    Public Const ENGLISH As Integer = 250
    Public Const GREEK As Integer = 300
    'Public Const CELTIC As Integer = 400
    Public Const LOCAL_CELTIC As Integer = 401
    Public Const BRETON As Integer = 410
    'Public Const WELSH As Integer = 420
    'Public Const IRISH As Integer = 430
    Public Const LOCAL_SLAVIC As Integer = 501
    'Public Const WEST_SLAVIC As Integer = 510
    'Public Const SOUTH_SLAVIC As Integer = 520
    'Public Const EAST_SLAVIC As Integer = 530
    'Public Const ARABIC As Integer = 600
    Public Const LOCAL_ARABIC As Integer = 601
    Public Const TURKIC As Integer = 700
    'Public Const LOCAL_TURKIC As Integer = 701

    Public LOCAL_LANGUAGE_COLOR As System.Drawing.Color = Color.LightGray
    'Public ROMANCE_LANGUAGE_COLOR As System.Drawing.Color = Color.White
    Public FRENCH_LANGUAGE_COLOR As System.Drawing.Color = Color.White
    Public LANGUEDOIL_LANGUAGE_COLOR As System.Drawing.Color = Color.AntiqueWhite
    Public LANGUEDOC_LANGUAGE_COLOR As System.Drawing.Color = Color.GhostWhite
    'Public LOCAL_FRENCH_LANGUAGE_COLOR As System.Drawing.Color = Color.GhostWhite
    'Public IBERIAN_LANGUAGE_COLOR As System.Drawing.Color = Color.YellowGreen
    Public LOCAL_IBERIAN_COLOR As System.Drawing.Color = Color.YellowGreen
    'Public ITALIAN_LANGUAGE_COLOR As System.Drawing.Color = Color.GreenYellow
    Public LOCAL_ITALIAN_COLOR As System.Drawing.Color = Color.GreenYellow
    'Public GERMANIC_LANGUAGE_COLOR As System.Drawing.Color = Color.CadetBlue
    'Public GERMAN_LANGUAGE_COLOR As System.Drawing.Color = Color.CadetBlue
    Public LOCAL_GERMANIC_COLOR As System.Drawing.Color = Color.CadetBlue
    Public ENGLISH_LANGUAGE_COLOR As System.Drawing.Color = Color.LightCoral
    Public GREEK_LANGUAGE_COLOR As System.Drawing.Color = Color.Fuchsia
    'Public CELTIC_LANGUAGE_COLOR As System.Drawing.Color = Color.RosyBrown
    Public LOCAL_CELTIC_COLOR As System.Drawing.Color = Color.RosyBrown
    Public BRETON_COLOR As System.Drawing.Color = Color.RosyBrown
    'Public SLAVIC_LANGUAGE_COLOR As System.Drawing.Color = Color.Aquamarine
    Public LOCAL_SLAVIC_COLOR As System.Drawing.Color = Color.Aquamarine
    'Public ARABIC_LANGUAGE_COLOR As System.Drawing.Color = Color.LimeGreen
    Public LOCAL_ARABIC_COLOR As System.Drawing.Color = Color.LimeGreen
    Public TURKIC_LANGUAGE_COLOR As System.Drawing.Color = Color.Khaki

    Public Const MINOR_LINGUISTIC_THRESHHOLD As Integer = 9

    Public Const LOCAL_LANGUAGE_STR As String = "Local"
    'Public Const ROMANCE_STR As String = "Romance"
    'Public Const LOCAL_ROMANCE_STR As String = "Romance"
    Public Const FRENCH_STR As String = "French"
    'Public Const LOCAL_FRENCH_STR As String = "Local French"
    Public Const LANGUEDOC_STR As String = "Langue d'oc"
    Public Const LANGUEDOIL_STR As String = "Langue d'oil"
    'Public Const SPANISH_STR As String = "Spanish"
    Public Const LOCAL_IBERIAN_STR As String = "Iberian"
    Public Const LOCAL_ITALIAN_STR As String = "Italian"
    'Public Const GERMANIC_STR As String = "Germanic"
    Public Const LOCAL_GERMANIC_STR As String = "Germanic"
    Public Const ENGLISH_STR As String = "English"
    Public Const GREEK_STR As String = "Greek"
    'Public Const CELTIC_STR As String = "Celtic"
    Public Const LOCAL_CELTIC_STR As String = "Celtic"
    Public Const BRETON_STR As String = "Breton"
    'Public Const SLAVIC_STR As String = "Slavic"
    Public Const LOCAL_SLAVIC_STR As String = "Slavic"
    'Public Const ARABIC_STR As String = "Arabic"
    Public Const LOCAL_ARABIC_STR As String = "Arabic"
    Public Const TURKIC_STR As String = "Turkic"

    'Qualitative estimates of probabiliies
    Public Const ADMINISTRATIVE_LOAD_THRESHHOLD As Integer = 10 'arbitrary

    ' Generic Government IDs
    Public Const LOCAL_CONTROL As Integer = 0
    Public Const POWER_1 As Integer = 1
    Public Const POWER_2 As Integer = 2
    Public Const POWER_3 As Integer = 3
    Public Const POWER_4 As Integer = 4
    Public Const POWER_5 As Integer = 5
    Public Const POWER_6 As Integer = 6
    Public Const POWER_7 As Integer = 7
    Public Const POWER_8 As Integer = 8
    Public Const POWER_9 As Integer = 9
    Public Const POWER_10 As Integer = 10

    Public Const POWER_11 As Integer = 11
    Public Const POWER_12 As Integer = 12
    Public Const POWER_13 As Integer = 13
    Public Const POWER_14 As Integer = 14
    Public Const OTHER_CONTROLLER As Integer = 15

    'Fall of Rome Scenario IDs ' Note that these are variables, not contants
    Public FranksID As Integer = POWER_1
    Public VisigothsID As Integer = POWER_2
    Public BurgundiansID As Integer = POWER_3
    Public OstragothsID As Integer = POWER_4
    Public VandalsID As Integer = POWER_5
    Public EasternEmpireID As Integer = POWER_6
    Public BasquesID As Integer = POWER_7
    Public AlemanniID As Integer = POWER_8
    Public SyariansID As Integer = POWER_9
    Public SueviID As Integer = POWER_10
    Public AvarsID As Integer = UNDEFINED

    'Public Const FRANKISH As Integer = POWER_1
    Public Const MAX_GOVERNMENTS As Integer = 15 'NOTE THIS DOESN'T INCLUDE SPACE FOR "OTHER_CONTROLLER": only the original 11 plusthe four spares

    Public LOCAL_CONTROL_COLOR As System.Drawing.Color = Color.Gainsboro '- was
    Public POWER_1_COLOR As System.Drawing.Color = Color.White 'LightBlue 'LightBlue 'Snow 'White ' 'DodgerBlue
    Public POWER_2_COLOR As System.Drawing.Color = Color.DodgerBlue '.Gold 'Orange
    Public POWER_3_COLOR As System.Drawing.Color = Color.Red '.DodgerBlue 'Aquamarine 'CornflowerBlue 'LightBlue
    Public POWER_4_COLOR As System.Drawing.Color = Color.Plum '.Lime
    Public POWER_5_COLOR As System.Drawing.Color = Color.Orange
    Public POWER_6_COLOR As System.Drawing.Color = Color.Goldenrod 'Orchid
    Public POWER_7_COLOR As System.Drawing.Color = Color.Fuchsia 'Aquamarine 'CornflowerBlue 'Goldenrod 'DarkKhaki 'oRAN 'red
    Public POWER_8_COLOR As System.Drawing.Color = Color.Lime '.Aquamarine 'Goldenrod 'MistyRose 'lightblue
    Public POWER_9_COLOR As System.Drawing.Color = Color.LightGreen '.Plum 'Orchid 'Fuchsia
    Public POWER_10_COLOR As System.Drawing.Color = Color.MistyRose 'Goldenrod 'MistyRose
    Public DISTANT_KINGDOM_COLOR As System.Drawing.Color = Color.Gainsboro 'Lavender - was

    'Extra colors for later
    Public POWER_11_COLOR As System.Drawing.Color = Color.OrangeRed
    Public POWER_12_COLOR As System.Drawing.Color = Color.Yellow
    Public POWER_13_COLOR As System.Drawing.Color = Color.MistyRose
    Public POWER_14_COLOR As System.Drawing.Color = Color.CornflowerBlue


    Public AffiliationColors() As System.Drawing.Color
    Public MaxAffiliationColors As Integer = 16

    ' 600 Scenario Values
    'Public Const LOCAL_CONTROL As Integer = 0
    'Public Const FRANKISH As Integer = 1
    'Public Const VISIGOTHIC As Integer = 2
    'Public Const BURGUNDIAN As Integer = 3
    'Public Const OSTROGOTHS As Integer = 4
    'Public Const VANDALS As Integer = 5
    'Public Const BYZANTINE As Integer = 6
    'Public Const BASQUES As Integer = 7
    'Public Const ALEMANNI As Integer = 8
    'Public Const SYAGRIAN As Integer = 9
    'Public Const SUEVI As Integer = 10
    'Public Const OTHER_CONTROLLER As Integer = 11

    'Public Const LOCAL_CONTROL_STRING As String = "Local"
    'Public Const FRANKISH_STRING As String = "Franks"
    'Public Const VISIGOTHIC_STRING As String = "Visigoths"
    'Public Const BURGUNDIAN_STRING As String = "Bavarians"
    'Public Const OSTROGOTH_STRING As String = "Lombards"
    'Public Const VANDAL_STRING As String = "Arabs"
    'Public Const BYZANTINE_STRING As String = "Byzantium"
    'Public Const BASQUE_STRING As String = "Avars"
    'Public Const ALEMANNI_STRING As String = "Alemanni"
    'Public Const SYAGRIAN_STRING As String = "Syagrians"
    'Public Const SUEVI_STRING As String = "Suevi"
    'Public Const OTHER_CONTROLLER_STRING As String = "Other"

    'Public LOCAL_CONTROL_COLOR As System.Drawing.Color = Color.Gainsboro '- was
    'Public FRANKISH_COLOR As System.Drawing.Color = Color.White 'LightBlue 'LightBlue 'Snow 'White ' 'DodgerBlue
    'Public NEIGHBOR_1_COLOR As System.Drawing.Color = Color.Gold 'Orange
    'Public NEIGHBOR_2_COLOR As System.Drawing.Color = Color.Aquamarine 'CornflowerBlue 'DodgerBlue 'CornflowerBlue 'LightBlue
    'Public NEIGHBOR_3_COLOR As System.Drawing.Color = Color.Lime
    'Public NEIGHBOR_4_COLOR As System.Drawing.Color = Color.Orange
    'Public NEIGHBOR_5_COLOR As System.Drawing.Color = Color.Orchid
    'Public NEIGHBOR_6_COLOR As System.Drawing.Color = Color.CornflowerBlue 'Goldenrod 'DarkKhaki 'oRAN 'red
    'Public NEIGHBOR_7_COLOR As System.Drawing.Color = Color.Goldenrod 'MistyRose 'lightblue
    'Public NEIGHBOR_8_COLOR As System.Drawing.Color = Color.Fuchsia
    'Public NEIGHBOR_9_COLOR As System.Drawing.Color = Color.MistyRose 'Goldenrod 'MistyRose
    'Public DISTANT_KINGDOM_COLOR As System.Drawing.Color = Color.Gainsboro 'Lavender - was

    ''Extra colors for later
    'Public NEIGHBOR_10_COLOR As System.Drawing.Color = Color.OrangeRed
    'Public NEIGHBOR_11_COLOR As System.Drawing.Color = Color.Yellow
    'Public NEIGHBOR_12_COLOR As System.Drawing.Color = Color.MistyRose


    'Public AffiliationColors() As System.Drawing.Color
    'Public MaxAffiliationColors As Integer = 8

    Public Const AVARS_STR As String = "Avars"

    'Government Constants
    Public Const PEASANTS_PER_BENEFICE As Integer = 25
    Public Const WARRIOR_RATIO As Integer = 3

    Public Const NO_NAVY As Integer = 0
    Public Const COASTAL_SAIL As Integer = 1
    Public Const OCEANGOING_SAIL As Integer = 3
    Public Const COASTAL_STEAM As Integer = 2
    Public Const OCEANGOING_STEAM As Integer = 4

    Public Const NO_NAVY_STR As String = "None"
    Public Const COASTAL_SAIL_STR As String = "Coastal"
    Public Const OCEANGOING_SAIL_STR As String = "Oceangoing"
    Public Const COASTAL_STEAM_STR As String = "Coastal Steam"
    Public Const OCEANGOING_STEAM_STR As String = "Oceangoing Steam"

    Public Const VIGOROUS As Integer = 2
    Public Const LACKLUSTER As Integer = 1
    Public Const DISARRAY As Integer = 0

    Public Const VIGOROUS_STR As String = "Vigorous"
    Public Const LACKLUSTER_STR As String = "Distracted"
    Public Const DISARRAY_STR As String = "In Disarray"

    Public Const GENIUS As Integer = 2
    Public Const TALENTED As Integer = 1
    Public Const MEDIOCRE As Integer = 0
    Public Const INEPT As Integer = -1
    Public Const DISASTROUS As Integer = -2

    Public Const UNDEFINED As Integer = -3

    Public Const GENIUS_STR As String = "Brilliant"
    Public Const TALENTED_STR As String = "Talented"
    Public Const MEDIOCRE_STR As String = "Average"
    Public Const INEPT_STR As String = "Inferior"
    Public Const DISASTROUS_STR As String = "Worthless"
    Public Const UNDEFINED_STR As String = "Uncertain"


    Public Const FANATICAL As Integer = 2
    Public Const PROFICIENT As Integer = 1
    Public Const STOLID As Integer = 0
    Public Const UNRELIABLE As Integer = -1
    Public Const INEFFECTUAL As Integer = -2

    Public Const FANATICAL_STR As String = "Indominable"
    Public Const PROFICIENT_STR As String = "Confident"
    Public Const STOLID_STR As String = "Stolid"
    Public Const UNRELIABLE_STR As String = "Unreliable"
    Public Const INEFFECTUAL_STR As String = "Ineffectual"

    Public Const NO_ACTION As Integer = -1
    Public Const WAITING As Integer = 0
    Public Const ATTACKING As Integer = 1
    Public Const RULING As Integer = 2
    Public Const BUILDING As Integer = 3
    Public Const PATRONIZING As Integer = 4
    Public Const PARLEYING As Integer = 5
    Public Const INTRODUCTION As Integer = 100
    Public Const EXPLORING As Integer = 110

    Public Const NO_SELECTION_STRING As String = "No Selection"
    Public Const WAIT_STRING As String = "        Wait"
    Public Const ATTACK_STRING As String = "      Attack"
    Public Const RULE_STRING As String = "        Rule"
    Public Const BUILD_STRING As String = "        Build"
    Public Const PATRONIZE_STRING As String = "    Patronize"
    Public Const PARLEY_STRING As String = "    Negotiate"
    Public Const EXPLORE_STRING As String = "       Explore"

    Public Const DESIGNATE_ACTION_TARGET As Integer = 1
    Public Const DESIGNATE_ATTACK_BASE As Integer = 2
    Public Const ADMINISTER As Integer = 10
    Public Const CONVERT As Integer = 11
    Public Const PROMULGATE_LAW_CODE As Integer = 12

    Public Const NO_PHASE_STRING As String = "No Action Selected"
    Public Const HOW_RULE_NOT_PICKED_STR As String = "No Form Selected"
    Public Const SELECT_TARGET_STRING As String = "Selecting Target"
    Public Const SELECT_BASE_STRING As String = "Selecting Base"

    Public Const ADMINISTER_STRING As String = "Ride the Circuit"
    Public Const CONVERT_STRING As String = "Convert to Christianity"
    Public Const PROMULGATE_LAW_CODE_STR As String = "Issue Law Code"

    Public Const EXPLORE_PHASE_STRING As String = "           - "

    Public Const ATTACK_PHASE_LBL As String = "Current Phase:"
    Public Const HOW_RULE_LBL As String = "Form of Ruling:"

    'Diplomacy Constants
    Public Const ALLIED As Integer = 2
    Public Const FRIENDLY As Integer = 1
    Public Const NEUTRAL As Integer = 0
    Public Const HOSTILE As Integer = -1
    Public Const ENEMY As Integer = -2
    Public Const NO_POWER As Integer = -5
    Public Const SELF As Integer = -9

    'Range of Diplomacy Variables; used in Clovis scenario to simplify diplomacy
    Public MAX_RELATES As Integer = 1
    Public MIN_RELATES As Integer = -1

    ' For Power ration calculations
    Public Const EQUAL_POWER As Integer = -1

    Public GovernmentLabelStr As String = "Kingdom"  'for general description of government pre-and post-French Rev

    ' Extremes turned off in Clovis Scenario
    'Public Const ALLIED_STR As String = "Allied"
    Public Const FRIENDLY_STR As String = "Friendly"
    Public Const NEUTRAL_STR As String = "Neutral"
    Public Const HOSTILE_STR As String = "Hostile"
    'Public Const ENEMY_STR As String = "Belligerent"
    Public Const NO_POWER_STR As String = "(Local)"
    Public SELF_STR As String = "You"              'note this is variable, not constant, because may change during game

    ' Reputations (Diplomatic)
    Public Const HONEST As Integer = 1
    Public Const UNCERTAIN As Integer = 0
    Public Const DISHONEST As Integer = -1

    Public Const MIN_REPUTE As Integer = DISHONEST
    Public Const MAX_REPUTE As Integer = HONEST

    Public Const HONEST_STR As String = "Reliable"
    Public Const UNCERTAIN_STR As String = "Uncertain"
    Public Const DISHONEST_STR As String = "Duplicitous"

    'Public ENEMY_COLOR As System.Drawing.Color = Color.Red
    Public HOSTILE_COLOR As System.Drawing.Color = Color.LightCoral
    Public NEUTRAL_COLOR As System.Drawing.Color = Color.Beige
    Public FRIENDLY_COLOR As System.Drawing.Color = Color.Chartreuse
    'Public ALLIED_COLOR As System.Drawing.Color = Color.Gold
    Public SELF_COLOR As System.Drawing.Color = POWER_1_COLOR 'Note this is a variable too, as could change
    Public NO_POWER_COLOR As System.Drawing.Color = LOCAL_CONTROL_COLOR

    Public Const MAXIMUM_ACCORD_PROBABILITY As Integer = 20 ' note: may have to adjust way of estimating probability of accord in msg if change this

    Public Const ELIMINATED_POWER_STRING As String = "Eliminated"

    Public Const LAW_CODE_COST As Integer = 20

    Public Const NO_LAW_CODE As Integer = 0
    Public Const TRIBAL_CODE As Integer = 1
    Public Const FEUDAL_CODE As Integer = 2
    Public Const IMPERIAL_CODE As Integer = 3
    Public Const INDUSTRIAL_CODE As Integer = 4

    Public Const NO_CODE_STR As String = "None"
    Public Const TRIBAL_CODE_STR As String = "Tribal"
    Public Const FEUDAL_CODE_STR As String = "Feudal"
    Public Const IMPERIAL_CODE_STR As String = "Imperial"
    Public Const INDUSTRIAL_CODE_STR As String = "Industrial"

    Public Const NEAR_VICTORY As Integer = 25
    'Public Const MARGINAL_VICTORY As Integer = VictoryPointGoal 'Can't assign this, but put here as reminder
    Public Const SUBSTANTIAL_VICTORY As Integer = 35
    Public Const DECISIVE_VICTORY As Integer = 45

    Public Const NEAR_VICTORY_STR As String = "Near"
    Public Const MARGINAL_VICTORY_STR As String = "Marginal" 'achieved by get Victory point Goal or just over
    Public Const SUBSTANTIAL_VICTORY_STR As String = "Substantial"
    Public Const DECISIVE_VICTORY_STR As String = "Decisive"

    '----------------------------------------------------------------------
    ' GLOBAL SYSTEM VARIABLES

    Public Playing As MsgBoxResult = vbYes   'Playing game or doing data input?

    Public StartDateTimeStr As String = ""

    'Clovis Info
    'Public ScenarioStartDate As Integer = 480  'Utimately should be part of scenario file input
    'Public ScenarioEndDate As Integer = 540 'ditto
    'Public VictoryPointGoal As Integer = 30 'ditto
    'Capetian Info
    Public ScenarioStartDate As Integer = 980  'Utimately should be part of scenario file input
    Public ScenarioEndDate As Integer = 1340 'ditto
    Public VictoryPointGoal As Integer = 30 'ditto

    Public SelectedArea As Integer = 0            'Use to ID area physically selected as part of set up player action
    Public SelectedType As Integer = 1            'Used in conjunction with Selected Area to distinguish Land and Water areas
    Public SelectedGovernment As Integer = 0       'Used mainly with display info box about government, and/or record new data

    Public TotalAreas As Integer = 0             'These values are set by import data procedures so know how many of each type of thing in game
    Public TotalProvinces As Integer = 0
    Public TotalSeas As Integer = 0
    Public TotalConnectors As Integer = 0
    Public TotalGovernments As Integer = 0

    Public PlayerSide As Integer = POWER_1
    Public CurrentAction As Integer = 0             'Which place in Action Queue being executed
    Public TotalActions As Integer = 0              'Set in creating Action Queue
    'Public PlayerActivated As Boolean = False
    'Public NewTurn As Boolean = False
    Public ActiveGovernment As Integer = -1         'Value in Current Action's place in Action Queue

    Public PlayerAction As Integer = NO_SELECTION     'What Action active Government is doing
    Public ActionPhase As Integer = 0
    Public TurnDate As Integer = 480 ' set so years before 480 so startof turn will advance it to correct start


    Public PlayerTarget As Integer = -1
    Public TargetBox As System.Windows.Forms.Control
    Public PlayerBase As Integer = -1
    Public BaseBox As System.Windows.Forms.Control

    Public PromptSelectTarget As Boolean = True
    Public PromptSelectBase As Boolean = True

    Public Const NO_MESSAGES = 0
    Public Const PLAYER_MESSAGES = 1
    Public Const ALL_MESSAGES = 2
    Public ViewLevel As Integer ' to control how many messages are shown during play ' not used as yet 3/28/13

    Public Const BASE_PROVINCE_SIZE = 250         'to determine how "conquerable" a province is

    Public CurrencyStr As String = "Denari"

    Public Local_Control_Str As String = "Local"
    Public FrankishStr As String = "Franks"
    'Public VISIGOTHIC_STRING As String = "Visigoths"
    'Public BURGUNDIAN_STRING As String = "Burgundians"
    'Public OSTROGOTH_STRING As String = "Ostragoths"
    'Public VANDAL_STRING As String = "Vandals"
    'Public BYZANTINE_STRING As String = "E.Empire"
    'Public BASQUE_STRING As String = "Basques"
    'Public ALEMANNI_STRING As String = "Alemanni"
    'Public SYAGRIAN_STRING As String = "Syagrians"
    'Public SUEVI_STRING As String = "Suevi"
    'Public OTHER_CONTROLLER_STRING As String = "Other"


    '----------------------------------------------------------------------------
    'VICTORY CONDITION CONSTANTS AND VARIABLES

    Public ProvincesAtStart As Integer = 6

    ' The Goals
    Public ConquestVPs As Integer = 0 'remember, these currently used to remember specific number of provinces conquered in Conversion calculations!
    Public SocialVPs As Integer = 0
    Public CulturalVPs As Integer = 0
    Public TotalVPs As Integer = 0

    ' VP Types
    'Public Const CONQUEST As Integer = 1
    'Public Const SOCIAL_IMPROVEMENT As Integer = 2
    'Public Const SOCIAL_IMPROVEMENT_2 As Integer = 3
    'Public Const CULTUAL_ACHIEVEMENT As Integer = 4

    'VP values
    Public Const PROVINCE_VP_VALUE = 1

    Public Const SOCIAL_STATE_VP_VALUE = 1
    Public Const GOLDEN_AGE_VP_VALUE = 2

    Public Const MINOR_CULTURAL_ACHIEVEMENT_VP_VALUE = 1
    Public Const MAJOR_CULTURAL_ACHIEVEMENT_VP_VALUE = 10

    Public Const CONQUEST_VP_LBL_BASE As String = "Provinces Conquered:  "
    Public Const SOCIAL_STATE_VP_LBL_BASE As String = "Social States Improved:"
    Public Const CULTURE_VP_LBL_BASE As String = "Cultural Achievement:  "
    Public Const TOTAL_VP_LBL_BASE As String = "TOTAL Victory Points:  "

    ' ---------------------------------------------------------------------------
    ' GLOBAL ARRAAYS

    Public WeatherByArea(CLIMATE_ZONES) As Integer

    Public ActionQueue() As Integer


    '----------------------------------------------------------------------------
    ' MAIN DATA STRUCTURES

    Public Structure Areas
        Public ID As Integer
        Public Name As String
        Public Type As Integer
        Public MapElement As String
        Public Topography As Integer
        Public Province As Integer
        'Public Climate As Integer

    End Structure

    Public Const NUM_FIELDS_IN_AREAS As Integer = 6

    Public Area() As Areas

    Public Structure Provinces

        Public ID As Integer
        Public Name As String
        Public MapElement As String
        Public Topography As Integer
        Public Climate As Integer
        Public Connectors() As Integer
        Public ConnectorNames() As String
        Public Neighbors() As Integer
        Public AreaNumber As Integer
        Public PoliticalAffiliation As Integer
        'Public Wilderness As Integer
        Public Farmland As Integer
        Public Peasants As Integer
        Public AgricultureLevel As Integer
        Public SurplusPopulation As Integer
        Public HarvestActual As Integer
        Public Nobles As Integer
        Public Clergy As Integer
        Public Townspeople As Integer
        Public SocialState As Integer
        'need to be added to Load/Save process: ' I think they are now, but double check before removing this
        Public Loyalty As Integer
        Public Religion As Integer
        Public Language As Integer

    End Structure

    Public Const NUM_FIELDS_IN_PROVINCES As Integer = 37 'with Language added, 36 'includes both Loyalty and Religion; was 34 ' NEED TO INCREASE TO 35 WHEN ADD Loyalty IN !!'30 before Nobles etc 'before Climate 29 '23 - before added in Connector Names

    Public Province() As Provinces

    Public Structure Seas
        Public ID As Integer
        Public Name As String
        Public MapElement As String
        Public Connectors() As Integer
        Public ConnectorNames() As String
        Public Neighbors() As Integer
        Public AreaNumber As Integer
        Public Topography As Integer
        Public Climate As Integer
        Public Controller As Integer ' this is for military control eventually
    End Structure

    Public Const NUM_FIELDS_IN_SEAS As Integer = 61  '60 before added climate '42 - before added in connector names '24 - before Max Neighbors increased to 18

    Public Sea() As Seas

    Public Structure Connectors
        Public ID As Integer
        Public Name As String
        'Public Color As System.Drawing.Color 'seems to create wierd record, and not really needed
        Public Type As Integer
        Public X1 As Integer
        Public Y1 As Integer
        Public OneEnd As Integer
        Public X2 As Integer
        Public Y2 As Integer
        Public OtherEnd As Integer
    End Structure

    Public Connector() As Connectors

    Public Structure Governments
        Public ID As Integer
        Public Name As String
        Public LeadershipState As Integer
        Public Generalship As Integer
        'Public Statesmanship As Integer
        'Public Taste As Integer
        Public Treasury As Integer
        Public TotalBenefices As Integer
        Public RoyalEstates As Integer
        'Public Benefices As Integer
        Public Cavalary As Integer
        Public Infantry As Integer
        Public ArmyState As Integer
        'need to be added to Load/Save process: 'done
        Public Support As Integer
        Public Religion As Integer
        Public PoliticalSavvy As Integer
        Public Language As Integer
        Public DiplomaticRelations() As Integer 'Remember: these added in to NUM_FIELDS_IN_GOVERNMENT_ during load at runtime!!
        Public LawCode As Integer
        Public NavalCapability As Integer
        Public Reputation As Integer
    End Structure

    Public Const NUM_FIELDS_IN_GOVERNMENTS As Integer = 17 ' plus # of Governments have relations with; see notes below:
    '17 with Reputation '16 with NavalCap; 15 with LawCode'+ TotalGovernments ADDED IN DURING LOAD AT RUNTIME FOR DIPLO RELATIONS ARRAY !!! 'with Savvy and Language added; 12 'now that Religion added up from 11 '10 - support added to io ' NEEDS TO BE INCREASED TO 11 WHEN ADD Support IN !! 'was 9 but split benefices

    Public Government() As Governments

    'Public ActionQueue() As Integer

    'Public Value As Integer
    'Public ID As Integer
    'Geography
    'Public Ports As Integer
    'Public Waterways As Integer
    'Public Roads As Integer
    'Public Fields As Integer
    'Public Forest As Integer
    'Public Neighbors As Array() 'check out how implement this
    ''Population 
    'Public Rural As Integer
    'Public Urban As Integer
    ''Economy
    'Public AgriculturalBase As Integer
    'Public Harvest As Integer
    'Public 
    '' Society
    'Public Peasants As Integer
    'Public Aristocrats As Integer
    'Public Clergy As Integer
    'Public Merchants As Integer
    'Public Artisans As Integer
    'Public Bureaucrats As Integer
    ' End Structure
End Module
