﻿Module Module2

    Sub DoSocioeconomicChange()
        Dim ProvinceNum As Integer = 0
        Dim Farmers As Integer = 0
        Dim i As Integer = 0
        Dim FoodAvailable As Integer = 0
        Dim FoodNeeded As Integer = 0
        Dim TowniesSupportedByNobles As Integer = 0
        Dim TowniesAtStart As Integer = 0
        Dim PlagueHits As Boolean = False
        Dim PlagueWave As Integer = 1

        DetermineWeather()

        If TurnDate >= 540 And TurnDate < 600 Then
            'MsgBox("Plague Hits!")
            PlagueHits = True
            PlagueWave = ((TurnDate) - 520) \ 20
            If TurnDate = 540 Then
                MsgBox("Travellers report that a Terrible Plague has struck the Eastern Empire and is spreading Everywhere, bringing untold Death and Misery!")
            Else
                MsgBox("The Plague has come again, bringing another wave of Suffering and Death!")
            End If
        End If


        For ProvinceNum = 0 To TotalProvinces - 1

            If Province(ProvinceNum).SocialState < 0 Then
                Province(ProvinceNum).SocialState += 1
            End If

            If Province(ProvinceNum).SocialState > 0 Then
                Province(ProvinceNum).SocialState -= 1
            End If

            If PlagueHits Then
                Sufferplague(ProvinceNum, PlagueWave)
            End If

            FoodAvailable = 0

            PopulationGrowth(ProvinceNum)

            If Province(ProvinceNum).Peasants > (Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel) Then
                Province(ProvinceNum).SurplusPopulation = Province(ProvinceNum).Peasants - (Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel)
            Else
                Province(ProvinceNum).SurplusPopulation = 0
            End If

            Province(ProvinceNum).Peasants -= Province(ProvinceNum).SurplusPopulation

            Province(ProvinceNum).HarvestActual = Province(ProvinceNum).Peasants + (Province(ProvinceNum).AgricultureLevel + WeatherByArea(Province(ProvinceNum).Climate)) * (Province(ProvinceNum).Peasants \ 20)

            FoodAvailable = Province(ProvinceNum).HarvestActual

            TowniesSupportedByNobles = Province(ProvinceNum).Nobles \ 2

            FoodAvailable -= Province(ProvinceNum).Nobles + Province(ProvinceNum).Clergy + TowniesSupportedByNobles

            If FoodAvailable >= Province(ProvinceNum).Peasants Then
                FoodAvailable -= Province(ProvinceNum).Peasants
            Else
                Province(ProvinceNum).SurplusPopulation += (Province(ProvinceNum).Peasants - FoodAvailable)
                Province(ProvinceNum).Peasants -= (Province(ProvinceNum).Peasants - FoodAvailable)

                If Province(ProvinceNum).Nobles > Province(ProvinceNum).Peasants \ 50 Then
                    Province(ProvinceNum).Nobles = Province(ProvinceNum).Peasants \ 50
                    Province(ProvinceNum).SurplusPopulation += 1
                    TowniesSupportedByNobles = Province(ProvinceNum).Nobles \ 2
                    DecrementSocialState(ProvinceNum, CHAOS)
                End If

                If Province(ProvinceNum).Clergy > Province(ProvinceNum).Peasants \ 50 Then
                    Province(ProvinceNum).Clergy = Province(ProvinceNum).Peasants \ 50
                    Province(ProvinceNum).SurplusPopulation += 1
                End If

                FoodAvailable = 0
                'If Province(ProvinceNum).SocialState > DISORDER Then
                '    Province(ProvinceNum).SocialState -= 1
                'End If
            End If

            If FoodAvailable >= (Province(ProvinceNum).Townspeople - TowniesSupportedByNobles) Then
                FoodAvailable -= (Province(ProvinceNum).Townspeople - TowniesSupportedByNobles)
            Else
                Province(ProvinceNum).SurplusPopulation += ((Province(ProvinceNum).Townspeople - TowniesSupportedByNobles) - FoodAvailable)
                Province(ProvinceNum).Townspeople -= ((Province(ProvinceNum).Townspeople - TowniesSupportedByNobles) - FoodAvailable)
                FoodAvailable = 0
                'If Province(ProvinceNum).SocialState > DISORDER Then
                '    Province(ProvinceNum).SocialState -= 1
                'End If
            End If

            If FoodAvailable > 0 Then

                TowniesAtStart = Province(ProvinceNum).Townspeople

                While FoodAvailable > 0
                    If Province(ProvinceNum).Townspeople <= 3 * TowniesAtStart \ 2 Then 'reflects limited ability of craft manu eco to expand; eventually should be removed to allow for foreign trade and industrialization
                        If Province(ProvinceNum).SurplusPopulation > 0 Then
                            Province(ProvinceNum).SurplusPopulation -= 1
                            FoodAvailable -= 1
                            Province(ProvinceNum).Townspeople += 1
                        Else
                            Province(ProvinceNum).Peasants -= 1
                            Province(ProvinceNum).Townspeople += 1
                            FoodAvailable -= 1
                        End If
                    Else
                        If Province(ProvinceNum).SurplusPopulation > 0 Then
                            Province(ProvinceNum).SurplusPopulation -= 1
                            FoodAvailable -= 1
                        Else
                            Exit While
                        End If
                    End If

                End While
            End If

            If Province(ProvinceNum).SurplusPopulation > 1 Then
                'Province(ProvinceNum).Peasants += SurplusPop
                DecrementSocialState(ProvinceNum, DISORDER)
                'MsgBox(Province(ProvinceNum).Name & " has " & CStr(Province(ProvinceNum).SurplusPopulation) & " surplus population to deal with.")
            Else
                If Province(ProvinceNum).SurplusPopulation = 1 Then
                    Province(ProvinceNum).Peasants += 1
                    Province(ProvinceNum).SurplusPopulation = 0
                End If
            End If

            If FoodAvailable > 1 Then
                IncrementSocialState(ProvinceNum, BOOMING)
                'MsgBox(Province(ProvinceNum).Name & " enjoyed great abundance.")
            End If



            'For i = 1 To Province(ProvinceNum).Townspeople
            '    If FoodAvailable > 0 Then
            '        FoodAvailable -= 1
            '    End If
            'Next i

        Next ProvinceNum

        'AdvanceDate()

        UpdateTextboxes()

        Migrate()

        frmMapScreen.rbnDiploRelatesText.PerformClick()
        frmMapScreen.rbnAutonomy.PerformClick()
        UpdateTextboxes()

        'Province(ProvinceNum).Peasants += CInt(Province(ProvinceNum).Peasants * 0.03) 'will need: + 0.01 * Province(ProvinceNum).SocialState) when add it
        'Province(ProvinceNum).SurplusPop = 0

        'Province(ProvinceNum).SurplusPopulation = 'note this was potential harvest until changed

        'DetermineActualHarvest(ProvinceNum)

        'Adjust Farmland to New Population Level
        'If Province(ProvinceNum).Peasants < Province(ProvinceNum).Farmland Then
        '    'Reduce Farmland by shortfall of peasants 'was divide by 2, but for now, it's total shortfall
        '    Province(ProvinceNum).Farmland = Province(ProvinceNum).Farmland - (Province(ProvinceNum).Farmland - Province(ProvinceNum).Peasants) ' \ 2
        'Else
        'End If


        'ReconcileFarmland()

        'Next ProvinceNum





    End Sub

    Public Sub UpdateTextboxes()


        If frmMapScreen.rbnPeasants.Checked = True Then
            frmMapScreen.rbnPeasants.Checked = False
            frmMapScreen.rbnPeasants.PerformClick()
        End If

        If frmMapScreen.rbnHarvest.Checked = True Then
            frmMapScreen.rbnHarvest.Checked = False
            frmMapScreen.rbnHarvest.PerformClick()
        End If

        If frmMapScreen.rbnNCT.Checked = True Then
            frmMapScreen.rbnNCT.Checked = False
            frmMapScreen.rbnNCT.PerformClick()
        End If

        If frmMapScreen.rbnAutonomy.Checked = True Then
            frmMapScreen.rbnAutonomy.Checked = False
            frmMapScreen.rbnAutonomy.PerformClick()
        End If

        If frmMapScreen.rbnWeather.Checked = True Then
            frmMapScreen.rbnWeather.Checked = False
            frmMapScreen.rbnWeather.PerformClick()
        End If

        If frmMapScreen.rbnSocialStateColor.Checked = True Then
            frmMapScreen.rbnSocialStateColor.Checked = False
            frmMapScreen.rbnSocialStateColor.PerformClick()
        End If

        If frmMapScreen.rbnAffiliation.Checked = True Then
            frmMapScreen.rbnAffiliation.Checked = False
            frmMapScreen.rbnAffiliation.PerformClick()
        End If


    End Sub

    Sub Migrate()
        Dim ProvinceNum As Integer = 0
        Dim PotentialTargetArea As Integer = -1
        Dim PotentialTarget As Integer = -1
        Dim CurrentTarget As Integer = -1
        Dim CurrentTargetValue As Integer = 0
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim k As Integer = 0
        Dim CoinFlip As Integer = 0
        Dim Rand As New Random
        Dim Strategy As Integer = 0
        Dim NeighboringSea As Integer = -1
        Dim TroopsToAdd As Integer = 0
        'Dim PopulationTransferred As Integer
        Dim TotalNewTroops As Integer = 0
        Dim NewTroopSources As Integer = 0
        Dim SourceProvinces() As Integer
        Dim MsgStr As String = ""

        Randomize()

        For ProvinceNum = 0 To TotalProvinces - 1

            If Province(ProvinceNum).SurplusPopulation > 0 Then
                'first see if internal migration within province will do the trick
                If Province(ProvinceNum).Peasants < (Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel) Then
                    Do
                        Province(ProvinceNum).SurplusPopulation -= 1
                        Province(ProvinceNum).Peasants += 1
                    Loop Until (Province(ProvinceNum).SurplusPopulation = 0) Or (Province(ProvinceNum).Peasants = (Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel))
                End If

                If Province(ProvinceNum).SurplusPopulation > 0 Then
                    If Province(ProvinceNum).PoliticalAffiliation = 0 Then
                        PotentialTarget = -1
                        CurrentTarget = -1
                        CurrentTargetValue = 0

                        For i = 0 To MAX_NEIGHBORS_LAND - 1 ' see if there's somewhere to move by land
                            If Province(ProvinceNum).Connectors(i) >= RIVER Then ' if neighbor is land connection
                                PotentialTargetArea = Province(ProvinceNum).Neighbors(i)
                                PotentialTarget = Area(PotentialTargetArea).Province
                                If (Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants) > CurrentTargetValue Then
                                    CurrentTarget = PotentialTarget
                                    CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                                Else
                                    If Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants = CurrentTargetValue Then
                                        CoinFlip = Rand.Next(0, 10) '2)
                                        If CoinFlip > 4 Then '= 1 Then
                                            CurrentTarget = PotentialTarget
                                            'CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                                        End If 'Coin flip says use the new one
                                    End If ' Neighbor is equal value to current 
                                End If ' Neighbor is better target than current
                            End If ' if Neighbor is land connection
                        Next ' i/Neighbor

                        If CurrentTarget = -1 Then 'if no land target found, check out by sea: current tech is only adjacent sea zone
                            For i = 0 To MAX_NEIGHBORS_LAND - 1
                                If Province(ProvinceNum).Connectors(i) = SEALANE Then
                                    PotentialTargetArea = Province(ProvinceNum).Neighbors(i)
                                    NeighboringSea = Area(PotentialTargetArea).Province
                                    If Sea(NeighboringSea).Topography = COASTAL Then 'will need to make this reflect maritime tech level eventually
                                        For j = 0 To MAX_NEIGHBORS_SEA - 1
                                            If Sea(NeighboringSea).Neighbors(j) >= 0 Then
                                                If Sea(NeighboringSea).Neighbors(j) <> ProvinceNum Then 'if not trying to invade itself
                                                    PotentialTargetArea = Sea(NeighboringSea).Neighbors(j)
                                                    'If Area(Sea(NeighboringSea).Neighbors(j)).Type = LAND Then
                                                    If Area(PotentialTargetArea).Type = LAND Then
                                                        PotentialTarget = Area(PotentialTargetArea).Province
                                                        If (Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants) > CurrentTargetValue Then
                                                            CurrentTarget = PotentialTarget
                                                            CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                                                        Else
                                                            If Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants = CurrentTargetValue Then
                                                                CoinFlip = Rand.Next(0, 10) '2)
                                                                If CoinFlip > 4 Then '= 1 Then
                                                                    CurrentTarget = PotentialTarget
                                                                    'CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                                                                End If 'Coin flip says use the new one
                                                            End If ' Neighbor is equal value to current 
                                                        End If ' Neighbor is better target than current
                                                    End If 'Neighbor to Sea Zone is a Land area
                                                End If 'not self 
                                                'Else ' if neighbor = -1, ie, no more neighbors 'no, testing Neighbors, not connections, so might be a sea area, with more land areas left to consider
                                                'Exit For
                                            End If ' Neighbor to sea zone exists
                                        Next 'Neigbor to Sea Zone
                                    End If 'isn't deep sea (ocean)
                                End If 'This is a Sea Connection
                            Next 'Neigbhor
                        End If 'No good targets by land

                        If CurrentTarget > -1 Then 'if a target was found

                            CoinFlip = Rand.Next(0, 10) '2) 'decide who wins by flip of coin for now.

                            If CoinFlip < 5 Then '= 1 Then
                                If Province(ProvinceNum).SurplusPopulation < CurrentTargetValue Then
                                    If CoinFlip < 5 Then '= 1 Then
                                        If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(CurrentTarget).PoliticalAffiliation = PlayerSide Then
                                            MsgBox(CStr(Province(ProvinceNum).SurplusPopulation) & ",000 migrants from " & Province(ProvinceNum).Name & _
                                                   " have settled in " & Province(CurrentTarget).Name & ".")
                                        End If ' if player knows
                                        Province(CurrentTarget).Peasants += Province(ProvinceNum).SurplusPopulation
                                        IncrementSocialState(ProvinceNum, BOOMING)
                                    Else
                                        If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(CurrentTarget).PoliticalAffiliation = PlayerSide Then
                                            MsgBox("Migrants from " & Province(ProvinceNum).Name & " forced their way into " & Province(CurrentTarget).Name & ", killing " _
                                               & CStr(Province(ProvinceNum).SurplusPopulation \ 2) & ",000 inhabitants.")
                                        End If
                                        Province(CurrentTarget).Peasants += Province(ProvinceNum).SurplusPopulation \ 2
                                        DecrementSocialState(CurrentTarget, CHAOS)
                                        IncrementSocialState(ProvinceNum, BOOMING)
                                        Province(CurrentTarget).PoliticalAffiliation = Province(ProvinceNum).PoliticalAffiliation
                                        'Province(CurrentTarget).SocialState -=
                                    End If 'Coinflip = 1
                                Else
                                    If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(CurrentTarget).PoliticalAffiliation = PlayerSide Then
                                        MsgBox("Migrants from " & Province(ProvinceNum).Name & " forced their way into " & Province(CurrentTarget).Name & ", killing " _
                                                & CStr(Province(ProvinceNum).SurplusPopulation) & ",000 inhabitants.")
                                    End If
                                    DecrementSocialState(CurrentTarget, CHAOS)
                                    IncrementSocialState(ProvinceNum, BOOMING)
                                    Province(CurrentTarget).PoliticalAffiliation = Province(ProvinceNum).PoliticalAffiliation
                                End If ' Target can accomodate settlers
                            Else ' coinflip = 0
                                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(CurrentTarget).PoliticalAffiliation = PlayerSide Then
                                    MsgBox("The inhabitants of " & Province(CurrentTarget).Name & " repelled invaders from " & Province(ProvinceNum).Name & ", killing " _
                                            & CStr(Province(ProvinceNum).SurplusPopulation) & ",000")
                                End If
                                'DecrementSocialState(ProvinceNum)
                            End If 'coinflip
                        Else ' no target
                            If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                                MsgBox("Famine in " & Province(ProvinceNum).Name & " has killed " & CStr(Province(ProvinceNum).SurplusPopulation) & ",000 people")
                            End If
                        End If ' no target
                        Province(ProvinceNum).SurplusPopulation = 0 ' one way or another, surplus pop is gone
                    Else 'is controlled by a government, and therefore surplus will join army instead of attack on own
                        TroopsToAdd = 0 ' 0 out the local variable from last province
                        TroopsToAdd = Province(ProvinceNum).SurplusPopulation \ WARRIOR_RATIO
                        If TroopsToAdd = 0 Then
                            TroopsToAdd = 1 'round up
                        End If

                        If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                            TotalNewTroops += TroopsToAdd
                            NewTroopSources += 1
                            ReDim Preserve SourceProvinces(NewTroopSources)
                            SourceProvinces(NewTroopSources - 1) = ProvinceNum
                        End If

                        Government(Province(ProvinceNum).PoliticalAffiliation).Infantry += TroopsToAdd
                        'Government(Province(ProvinceNum).PoliticalAffiliation).SurplusPop = True

                        '    If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                        '        MsgBox(CStr(TroopsToAdd) & ",000 Warriors from " & Province(ProvinceNum).Name _
                        '               & " have joined the " & Government(Province(ProvinceNum).PoliticalAffiliation).Name _
                        '               & " demanding conquests to provide land for their families.")
                        '    End If
                        'End If ' is an autonomous province

                    End If 'is an autonomous province
                End If 'Current province has suplus population not dealt with by internal migration
            End If ' Current Provincce has surplus population

        Next ' Province

        If TotalNewTroops > 0 Then
            frmMapScreen.rbnSurplusPopulation.PerformClick()
            'MsgBox(CStr(TroopsToAdd) & ",000 Warriors from " & Province(ProvinceNum).Name _
            '           & " have joined the " & Government(Province(ProvinceNum).PoliticalAffiliation).Name _
            '           & " demanding conquests to provide land for their families.")
            MsgStr = "A total of " & CStr(TotalNewTroops) & ",000 Warriors demanding Conquests to provide Land for their Families have joined your Army from "
            For i = 0 To NewTroopSources - 1
                If i > 0 Then
                    If NewTroopSources > 2 Then
                        MsgStr &= ", "
                    End If
                    If i = NewTroopSources - 1 Then
                        MsgStr &= "and "
                    End If
                End If
                Try
                    MsgStr &= Province(SourceProvinces(i)).Name
                Catch
                    MsgBox("ERROR: Problem with List of Provinces supplying Land hungry Warriors")
                End Try
            Next
            MsgStr &= "."
            MsgBox(MsgStr)
        End If

    End Sub

    Sub DecideIfNewTarget(ByVal PotentialTarget As Integer, ByVal ProvinceNum As Integer, CurrentTarget As Integer, CurrentTargetValue As Integer)
        Dim CoinFlip As Integer = 0
        Dim Rand As New Random

        If Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants > CurrentTargetValue Then
            CurrentTarget = PotentialTarget
            CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
        Else
            If Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants = CurrentTargetValue Then
                CoinFlip = Rand.Next(0, 1)
                If CoinFlip = 1 Then
                    CurrentTarget = PotentialTarget
                    CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                End If 'Coin flip says use the new one
            End If ' Neighbor is equal value to current 
        End If ' Neighbor is better target than current

    End Sub

    Sub DecrementSocialState(ByVal ProvinceNum As Integer, ByVal Floor As Integer)
        If Province(ProvinceNum).SocialState > Floor Then
            Province(ProvinceNum).SocialState -= 1
        End If
    End Sub

    Sub IncrementSocialState(ByVal ProvinceNum As Integer, ByVal Ceiling As Integer)
        If Province(ProvinceNum).SocialState < Ceiling Then
            Province(ProvinceNum).SocialState += 1
        End If
    End Sub

    Sub AdvanceDate()
        'Dim OldDate, NewDate As Integer

        'OldDate = CInt(frmMapScreen.lblDate.Text.Substring(0, 4))
        TurnDate += TURN_INTERVAL

        frmMapScreen.lblDate.Text = DATE_LBL_BASE & CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL) & " C.E."

    End Sub

    Sub Sufferplague(ByVal ProvNum As Integer, ByVal Wave As Integer)
        Dim PeasToLand As Integer = 1
        Dim i As Integer = 0
        Dim TowniesPre As Integer = Province(ProvNum).Townspeople
        Dim NoblesPre As Integer = Province(ProvNum).Nobles
        Dim ClergyPre As Integer = Province(ProvNum).Clergy
        Dim PeasPre As Integer = Province(ProvNum).Peasants
        Dim TotalPre As Integer = 0
        Dim TotalPost As Integer = 0
        Dim TotalDead As Integer = 0
        Dim DeadPercent As Integer = 0
        Dim NumDecrements As Integer = 0

        TotalPre = TowniesPre + NoblesPre + ClergyPre + PeasPre

        Province(ProvNum).Townspeople -= Province(ProvNum).Townspeople \ (2 * Wave)
        Province(ProvNum).Nobles = 2 * Province(ProvNum).Nobles \ 3
        'If Province(ProvNum).Nobles < 1 Then
        '    Province(ProvNum).Nobles = 1
        'End If
        Province(ProvNum).Clergy -= Province(ProvNum).Clergy \ (2 * Wave)
        PeasToLand = Province(ProvNum).Farmland \ Province(ProvNum).Peasants
        If PeasToLand < 1 Then PeasToLand = 1
        Province(ProvNum).Peasants -= (Province(ProvNum).Peasants) \ (PeasToLand + Wave + 2)

        TotalPost = Province(ProvNum).Townspeople + Province(ProvNum).Nobles + Province(ProvNum).Clergy + Province(ProvNum).Peasants
        TotalDead = TotalPre - TotalPost
        DeadPercent = CInt((CDec(TotalDead) / CDec(TotalPre)) * 100)

        NumDecrements = 4 - PeasToLand - Wave
        If NumDecrements > 0 Then
            For i = 1 To NumDecrements
                DecrementSocialState(ProvNum, CHAOS)
            Next
        End If
        If Province(ProvNum).PoliticalAffiliation = PlayerSide Then
            MsgBox("Plague Hits " & Province(ProvNum).Name & "!" & vbCrLf & vbCrLf _
                   & CStr(TotalDead) & ",000 out of " & CStr(TotalPre) & ",000 of the inhabitants have died!")
        End If

        'Province(ProvinceNum).Peasants -= CInt((CDec(Province(ProvinceNum).Peasants) / CDec(Province(ProvinceNum).Farmland * 2) * CDec(Province(ProvinceNum).Peasants)))

    End Sub



    Sub DetermineWeather()
        Dim Zone As Integer = 0
        Dim Weather As Integer = 0
        Dim DieRoll As Integer = 0
        'Dim RandomNum As Integer = 0
        Dim Rand As New Random
        Dim DieRoll1, DieRoll2 As Integer
        Dim Century As Integer = 0
        Dim SpecialWeather As Integer = -1
        'frmMapScreen.rbnWeather.Checked = True
        Dim ExtremeAreas As Integer = 0
        Dim ExtremeArea() As Integer
        Dim MsgStr As String = ""
        Dim i As Integer = 0
        Dim ExtremeBad As Integer = 0
        Dim ExtremeGood As Integer = 0


        Century = (TurnDate \ 100) + 1

        Randomize()

        For Zone = 1 To CLIMATE_ZONES - 1 ' "Zone 0" = areas outside Europe

            Select Case Century
                Case 5
                    DieRoll = 0
                Case 6
                    DieRoll = -1
                Case 7
                    DieRoll = -2
                Case 8
                    DieRoll = -1
                Case 9
                    DieRoll = 0
                Case 10
                    DieRoll = 0
                Case 11
                    DieRoll = 1
                Case 12
                    DieRoll = 1
                Case 13
                    DieRoll = 2
                Case 14
                    DieRoll = 1
                Case 15
                    DieRoll = 0
                Case 16
                    DieRoll = -1
                Case 17
                    DieRoll = -2
                Case 18
                    DieRoll = -1
                Case 19
                    DieRoll = 0
                Case 20
                    DieRoll = 1
                Case 21
                    DieRoll = 2
            End Select

            DieRoll1 = Rand.Next(1, 7) 'comment out TEMPORARILY to make it easier to see socioeconomic trends without randomized influence
            Select Case TurnDate
                Case 660, 1300, 1640, 2000
                    Select Case DieRoll1
                        Case 1, 2
                            WeatherByArea(Zone) = TERRIBLE_WEATHER
                        Case 3, 4
                            WeatherByArea(Zone) = BAD_WEATHER
                        Case 4, 6
                            WeatherByArea(Zone) = NORMAL_WEATHER
                    End Select
                Case Else
                    DieRoll2 = Rand.Next(1, 7)
                    'DieRoll1 = 7
                    'DieRoll2 = 7

                    DieRoll += DieRoll1 + DieRoll2

                    'If TurnDate = 480 Then
                    '    If Zone = 1 Or Zone = 2 Or Zone = 3 Or Zone = 5 Or Zone = 10 Then
                    '        DieRoll = 7
                    '    End If
                    'End If

                    Select Case DieRoll
                        Case 14, 1
                            WeatherByArea(Zone) = TERRIBLE_WEATHER
                            'MsgBox("Terrible Weather in Climate Zone " & CStr(i))
                        Case 2, 3
                            WeatherByArea(Zone) = BAD_WEATHER
                            'MsgBox("Bad Weather in Climate Zone " & CStr(i))
                        Case 11, 12
                            WeatherByArea(Zone) = GOOD_WEATHER
                            'MsgBox("Good Weather in Climate Zone " & CStr(i))
                        Case 13, 0
                            WeatherByArea(Zone) = GREAT_WEATHER
                            'MsgBox("Great Weather in Climate Zone " & CStr(i))
                        Case Else
                            WeatherByArea(Zone) = NORMAL_WEATHER
                    End Select
            End Select

            If WeatherByArea(Zone) <> NORMAL_WEATHER Then
                'Weather = WeatherByArea(Zone)
                ExtremeAreas += 1
                ReDim Preserve ExtremeArea(ExtremeAreas)
                ExtremeArea(ExtremeAreas - 1) = Zone
                'MsgBox(NameWeather(Weather) & " Weather in " & NameClimateZone(Zone) & " Zone.")
                'frmMapScreen.Refresh()
            End If
        Next

        frmMapScreen.rbnWeather.PerformClick()

        If ExtremeAreas > 0 Then
            For i = 0 To ExtremeAreas - 1
                Try
                    If WeatherByArea(ExtremeArea(i)) < 0 Then
                        If ExtremeBad = 0 Then
                            MsgStr = "UNUSUAL WEATHER PATTERNS: " & CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL) & DOUBLE_SPACE
                            MsgStr &= "Bad Weather prevails in: "
                        End If
                        ExtremeBad += 1
                        If ExtremeBad > 1 Then
                            MsgStr &= ", "
                        End If
                        MsgStr &= NameClimateZone(ExtremeArea(i))
                    End If
                Catch
                    MsgBox("ERROR: Problem with List of Provinces Areas with Bad Weather")
                End Try
            Next
            If ExtremeBad < ExtremeAreas Then
                If ExtremeBad <> 0 Then
                    MsgStr &= DOUBLE_SPACE
                Else ' if only good weather
                    MsgStr = "UNUSUAL WEATHER PATTERNS: " & CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL) & DOUBLE_SPACE
                End If
                MsgStr &= "Good Weather prevails in: "
                For i = 0 To ExtremeAreas - 1
                    Try
                        If WeatherByArea(ExtremeArea(i)) > 0 Then
                            ExtremeGood += 1
                            If ExtremeGood > 1 Then
                                MsgStr &= ", "
                            End If
                            MsgStr &= NameClimateZone(ExtremeArea(i))
                        End If
                    Catch
                        MsgBox("ERROR: Problem with List of Provinces Areas with Good Weather")
                    End Try
                Next
            End If
            MsgBox(MsgStr, MsgBoxStyle.OkOnly, CStr(TURN_INTERVAL) & " Year Weather Patterns")
        Else
            MsgBox("Weather Patterns Normal Throughout Europe from " & CStr(TurnDate) & " to " & CStr(TurnDate + TURN_INTERVAL) & ".", MsgBoxStyle.OkOnly, CStr(TURN_INTERVAL) & " Year Weather Patterns")
        End If
        'MsgBox(NameWeather(Weather) & " Weather in " & NameClimateZone(Zone) & " Zone.")


    End Sub

 
    Sub PopulationGrowth(ProvinceNum As Integer)
        Dim OldSOL As Integer = 0
        Dim Reprorate As Decimal
        Dim PopIncrease As Integer = 0
        Dim i As Integer = 0
        ' = 0.03

        OldSOL = Province(ProvinceNum).AgricultureLevel

        If Province(ProvinceNum).Peasants < (3 * Province(ProvinceNum).Farmland \ 4) Then
            OldSOL += Province(ProvinceNum).Farmland \ Province(ProvinceNum).Peasants
        End If

        OldSOL = OldSOL + WeatherByArea(Province(ProvinceNum).Climate)

        'OldSOL = OldSOL + Province(ProvinceNum).SocialState

        Reprorate = 0.01 * OldSOL '.03 per 20 years appears to be average 500=1340

        PopIncrease = Int(Province(ProvinceNum).Peasants * Reprorate) 'Int used instead of CInt to truncate rather than round (so .5 goes down, not up)

        Province(ProvinceNum).Peasants += PopIncrease

        'NEED A BETTER WAY TO ACCOUNT FOR RELATIONSHIP OF PEASANT POPULATION GROWTH AND GROWTH OF NOBLE & CLERGY POPS AND DISTRIBUTION OF LAND
        'If (Province(ProvinceNum).Peasants / PEASANTS_PER_BENEFICE) - (Province(ProvinceNum).Nobles + Province(ProvinceNum).Clergy) > 0 Then
        '    If Province(ProvinceNum).Nobles > 0 Then
        '        Province(ProvinceNum).Nobles()
        '    End If
        'End If

        'If Province(ProvinceNum).Nobles < Province(ProvinceNum).Peasants \ 50 Then
        '    Province(ProvinceNum).Nobles = Province(ProvinceNum).Peasants \ 50
        'End If

        'If Province(ProvinceNum).Clergy < Province(ProvinceNum).Peasants \ 50 Then
        '    Province(ProvinceNum).Clergy = Province(ProvinceNum).Peasants \ 50
        'End If

        'If Province(ProvinceNum).Townspeople < Province(ProvinceNum).Nobles \ 2 Then
        '    Province(ProvinceNum).Townspeople = Province(ProvinceNum).Nobles \ 2
        'End If

    End Sub

    Sub SetUpAvars(GovNum)
        Dim i As Integer = 0

        Government(GovNum).Name = AVARS_STR '"Avars" 'Note that this Replaces None
        Government(GovNum).Infantry = 0
        Government(GovNum).Cavalary = 300
        Government(GovNum).Language = TURKIC
        Government(GovNum).Religion = PAGAN
        Government(GovNum).Generalship = GENIUS
        Government(GovNum).ArmyState = FANATICAL
        Government(GovNum).LeadershipState = VIGOROUS
        Government(GovNum).PoliticalSavvy = TALENTED
        Government(GovNum).RoyalEstates = 0
        Government(GovNum).Support = ENTHUSIASTIC
        Government(GovNum).Treasury = 0
        Government(GovNum).TotalBenefices = 0

        For i = 0 To TotalGovernments - 1
            Government(GovNum).DiplomaticRelations(i) = HOSTILE
        Next

        For i = 0 To TotalProvinces - 1
            If Province(i).ID = "Russia" Or Province(i).Name = "Poland" Then
                Province(i).SocialState = ORDERLY
                Province(i).PoliticalAffiliation = GovNum
                Province(i).Peasants += 50
                Province(i).Nobles = 5
            Else
                If Province(i).Name = "E.Germany" Or Province(i).Name = "Balkans" Then
                    Province(i).SocialState = DISORDER
                End If
            End If
        Next
        frmMapScreen.Refresh()
    End Sub


End Module
