﻿
Module Module2

    Dim RandNum As New Random

    Dim DieRolls(1000) As Integer
    Dim DieRollIndex As Integer = 0

    Sub DoSocioeconomicChange()
        Dim ProvinceNum As Integer = 0
        Dim Farmers As Integer = 0
        Dim i As Integer = 0
        Dim FoodAvailable As Integer = 0
        Dim FoodNeeded As Integer = 0
        Dim TowniesSupportedByNobles As Integer = 0
        Dim TowniesAtStart As Integer = 0
        Dim PlagueHits As Boolean = False
        Dim PlagueWave As Integer = 1
        Dim TurnIndex As Integer = 0
        Dim Suzarien As Integer = 0
        Dim TotalPre As Integer = 0
        Dim TotalPost As Integer = 0
        Dim TotalDead As Integer = 0
        Dim DeadPercent As Integer = 0
        Dim SurplusAtStart As Integer = 0
        'Dim RandomNum As New Random

        'TurnIndex = TurnNum - 1 ' Don't need this; Turn Num is good because "Turn 0" is calculated as game starts

        ReDim Preserve TurnRecord(TurnNum) ' TurnIndex)


        DetermineWeather()

        If TurnDate >= 1350 And TurnDate < 1425 Then
            'MsgBox("Plague Hits!")
            PlagueHits = True
            PlagueWave = ((TurnDate) - 1325) \ 25
            'If TurnDate = 1350 Then
            '    MsgBox("A Terrible Plague is spreading Everywhere, bringing untold Death and Misery!")
            'Else
            '    MsgBox("The Plague has come again, bringing another wave of Suffering and Death!")
            'End If
        End If

        For ProvinceNum = 0 To TotalProvinces - 1

            If Province(ProvinceNum).SocialState < 0 Then
                Province(ProvinceNum).SocialState += 1
            End If

            If Province(ProvinceNum).SocialState > 0 Then
                Province(ProvinceNum).SocialState -= 1
            End If

            If PlagueHits Then
                TotalPre += Province(ProvinceNum).Peasants + Province(ProvinceNum).Nobles + Province(ProvinceNum).Clergy + Province(ProvinceNum).Townspeople ' + Province(ProvinceNum).SurplusPopulation
                Sufferplague(ProvinceNum, PlagueWave)
                TotalPost += Province(ProvinceNum).Peasants + Province(ProvinceNum).Nobles + Province(ProvinceNum).Clergy + Province(ProvinceNum).Townspeople ' + Province(ProvinceNum).SurplusPopulation
            End If

            If Province(ProvinceNum).AgricultureLevel < HighestAgriLevel Then ' for now use
                SeeIfNeighborMoreAgriAdvanced(ProvinceNum)
            End If
            'End If

            FoodAvailable = 0

            PopulationGrowth(ProvinceNum)

            If Province(ProvinceNum).Peasants > (Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel) Then
                Province(ProvinceNum).SurplusPopulation = Province(ProvinceNum).Peasants - (Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel)
            Else
                Province(ProvinceNum).SurplusPopulation = 0
            End If

            Province(ProvinceNum).Peasants -= Province(ProvinceNum).SurplusPopulation

            Province(ProvinceNum).HarvestActual += Province(ProvinceNum).Peasants + (Province(ProvinceNum).AgricultureLevel + WeatherByArea(Province(ProvinceNum).Climate)) * (Province(ProvinceNum).Peasants \ 25)
            ' += used in case in-migration happened from province processed before this one and they increased Harvest as came in (see Migrate sub)

            FoodAvailable = Province(ProvinceNum).HarvestActual

            'TowniesSupportedByNobles = Province(ProvinceNum).Nobles * CInt(Province(ProvinceNum).AgricultureLevel ^ 2) \ 2

            FoodAvailable -= Province(ProvinceNum).Nobles + Province(ProvinceNum).Clergy + Province(ProvinceNum).Townspeople '((3 * Province(ProvinceNum).Townspeople) \ 4) ' TowniesSupportedByNobles

            If FoodAvailable >= Province(ProvinceNum).Peasants Then
                FoodAvailable -= Province(ProvinceNum).Peasants
            Else
                Province(ProvinceNum).SurplusPopulation += (Province(ProvinceNum).Peasants - FoodAvailable)
                Province(ProvinceNum).Peasants -= (Province(ProvinceNum).Peasants - FoodAvailable)

                If Province(ProvinceNum).Nobles > Province(ProvinceNum).Peasants \ PEASANTS_PER_BENEFICE * 2 Then
                    'Province(ProvinceNum).Nobles = Province(ProvinceNum).Peasants \ PEASANTS_PER_BENEFICE * 2
                    Province(ProvinceNum).SurplusPopulation += 1
                    'TowniesSupportedByNobles = Province(ProvinceNum).Nobles \ 2
                    DecrementSocialState(ProvinceNum, CHAOS)
                End If

                If Province(ProvinceNum).Clergy > Province(ProvinceNum).Peasants \ PEASANTS_PER_BENEFICE * 2 Then
                    'Province(ProvinceNum).Clergy = Province(ProvinceNum).Peasants \ PEASANTS_PER_BENEFICE * 2
                    Province(ProvinceNum).SurplusPopulation += 1
                End If

                FoodAvailable = 0
                'If Province(ProvinceNum).SocialState > DISORDER Then
                '    Province(ProvinceNum).SocialState -= 1
                'End If
            End If

            Province(ProvinceNum).Nobles = Province(ProvinceNum).Peasants \ PEASANTS_PER_BENEFICE * 2
            'TowniesSupportedByNobles = Province(ProvinceNum).Nobles * CInt(Province(ProvinceNum).AgricultureLevel ^ 2) \ 2
            Province(ProvinceNum).Clergy = Province(ProvinceNum).Peasants \ PEASANTS_PER_BENEFICE * 2

            'If FoodAvailable >= (Province(ProvinceNum).Townspeople \ 4) Then '- TowniesSupportedByNobles) Then
            '    FoodAvailable -= (Province(ProvinceNum).Townspeople \ 4) ' - TowniesSupportedByNobles)
            'Else
            '    Province(ProvinceNum).SurplusPopulation += ((Province(ProvinceNum).Townspeople \ 4) - FoodAvailable) ' - TowniesSupportedByNobles) - FoodAvailable)
            '    Province(ProvinceNum).Townspeople -= ((Province(ProvinceNum).Townspeople \ 4) - FoodAvailable) ' - TowniesSupportedByNobles) - FoodAvailable)
            '    FoodAvailable = 0
            '    'If Province(ProvinceNum).SocialState > DISORDER Then
            '    '    Province(ProvinceNum).SocialState -= 1
            '    'End If
            'End If

            If FoodAvailable > 0 Then

                TowniesAtStart = Province(ProvinceNum).Townspeople
                SurplusAtStart = Province(ProvinceNum).SurplusPopulation

                While FoodAvailable > 0
                    If Province(ProvinceNum).Townspeople <= 4 * TowniesAtStart \ 3 Then 'reflects limited ability of craft manu eco to expand; eventually should be removed to allow for foreign trade and industrialization
                        If Province(ProvinceNum).SurplusPopulation > 0 Then
                            Province(ProvinceNum).SurplusPopulation -= 1
                            FoodAvailable -= 1
                            Province(ProvinceNum).Townspeople += 1
                        Else
                            Province(ProvinceNum).Peasants -= 1
                            Province(ProvinceNum).Townspeople += 1
                            FoodAvailable -= 1
                        End If
                    Else
                        If Province(ProvinceNum).SurplusPopulation * Province(ProvinceNum).AgricultureLevel > SurplusAtStart Then
                            Province(ProvinceNum).SurplusPopulation -= 1
                            Province(ProvinceNum).Peasants += 1
                            FoodAvailable -= 1
                        Else
                            Exit While
                        End If
                    End If

                End While
            End If

            If Province(ProvinceNum).SurplusPopulation > 1 Then
                'Province(ProvinceNum).Peasants += SurplusPop
                DecrementSocialState(ProvinceNum, DISORDER)
                'MsgBox(Province(ProvinceNum).Name & " has " & CStr(Province(ProvinceNum).SurplusPopulation) & " surplus population to deal with.")
            Else
                If Province(ProvinceNum).SurplusPopulation = 1 Then
                    Province(ProvinceNum).Peasants += 1
                    Province(ProvinceNum).SurplusPopulation = 0
                End If
            End If

            If FoodAvailable > 1 Then
                IncrementSocialState(ProvinceNum, BOOMING)
                'MsgBox(Province(ProvinceNum).Name & " enjoyed great abundance.")
            End If



            'For i = 1 To Province(ProvinceNum).Townspeople
            '    If FoodAvailable > 0 Then
            '        FoodAvailable -= 1
            '    End If
            'Next i


            If Province(ProvinceNum).FormalAffiliation = PlayerSide Then
                AddProvInfoToTurnRec(ProvinceNum, TurnNum)
            End If



        Next ProvinceNum

        If PlagueHits Then
            TotalDead = TotalPre - TotalPost
            DeadPercent = CInt((CDec(TotalDead) / CDec(TotalPre)) * 100)
            If TurnDate = 1350 Then
                MsgBox("A Terrible Plague has Ravaged the Population! " & _
                       CStr(TotalDead) & ",000 out of " & CStr(TotalPre) & ",000 of Your People have died!")
            Else
                MsgBox("The Plague has come again!  " & _
                       CStr(TotalDead) & ",000 out of " & CStr(TotalPre) & ",000 of Your People have died!")
            End If


        End If

        'AdvanceDate()

        UpdateTextboxes()

        Migrate()

        CalcTurnRecAverages(TurnNum)

        '' find averages of Weather and Pol. Control ' moved to CalcTurnRecAverages()
        'TurnRecord(TurnIndex).AverageWeather = Math.Round(TurnRecord(TurnIndex).AverageWeather / CDbl(TurnRecord(TurnIndex).ProvincesInFrance), 2)
        'TurnRecord(TurnIndex).AgriLevel = Math.Round(TurnRecord(TurnIndex).AgriLevel / CDbl(TurnRecord(TurnIndex).ProvincesInFrance), 2)
        'TurnRecord(TurnIndex).DegreeOfControl = Math.Round(TurnRecord(TurnIndex).DegreeOfControl / CDbl(TurnRecord(TurnIndex).ProvincesInFrance), 2)

        frmMapScreen.rbnDiploRelatesText.PerformClick()
        frmMapScreen.rbnAutonomy.PerformClick()
        UpdateTextboxes()

        'Province(ProvinceNum).Peasants += CInt(Province(ProvinceNum).Peasants * 0.03) 'will need: + 0.01 * Province(ProvinceNum).SocialState) when add it
        'Province(ProvinceNum).SurplusPop = 0

        'Province(ProvinceNum).SurplusPopulation = 'note this was potential harvest until changed

        'DetermineActualHarvest(ProvinceNum)

        'Adjust Farmland to New Population Level
        'If Province(ProvinceNum).Peasants < Province(ProvinceNum).Farmland Then
        '    'Reduce Farmland by shortfall of peasants 'was divide by 2, but for now, it's total shortfall
        '    Province(ProvinceNum).Farmland = Province(ProvinceNum).Farmland - (Province(ProvinceNum).Farmland - Province(ProvinceNum).Peasants) ' \ 2
        'Else
        'End If


        'ReconcileFarmland()

        'Next ProvinceNum





    End Sub

    Sub SeeIfNeighborMoreAgriAdvanced(ByVal ProvNum As Integer)
        Dim Neighbor As Integer = -1
        Dim ProbabilityAdvance As Integer = 0
        Dim LinguisticDif As Integer = 0
        'Dim ReligiousDif As Integer = 0
        Dim Crowdedness As Integer = 0
        Dim SocialState As Integer = 0
        Dim NumClergy As Integer = 0
        Dim ClimateDif As Integer = 0
        'Dim RandNum As New Random
        Dim DieRoll As Integer = 0

        'Randomize()

        SocialState = 0  'Province(ProvNum).SocialState
        Crowdedness = GetCrowdedness(ProvNum)
        NumClergy = Province(ProvNum).Clergy - (Province(ProvNum).Peasants \ (PEASANTS_PER_BENEFICE * 2))

        For i = 0 To MAX_NEIGHBORS_LAND - 1
            If Province(ProvNum).Neighbors(i) >= 0 Then
                If Area(Province(ProvNum).Neighbors(i)).Type = LAND Then
                    Neighbor = Area(Province(ProvNum).Neighbors(i)).Province
                    If Province(Neighbor).AgricultureLevel > Province(ProvNum).AgricultureLevel Then
                        LinguisticDif = GetLinguisticDif(ProvNum, Neighbor) '* 2
                        ClimateDif = GetClimateDif(ProvNum, Neighbor) * 2
                        ProbabilityAdvance = Crowdedness + SocialState + NumClergy - LinguisticDif - ClimateDif

                        If ProbabilityAdvance > 14 Then ProbabilityAdvance = 14
                        If ProbabilityAdvance < 0 Then ProbabilityAdvance = 0

                        DieRoll = RandNum.Next(0, 15)
                        DieRolls(DieRollIndex) = DieRoll
                        DieRollIndex += 1
                        If ProbabilityAdvance > DieRoll Then
                            Province(ProvNum).AgricultureLevel += 1
                            Exit Sub
                        End If
                    End If
                End If
            End If
        Next

    End Sub

    Function GetClimateDif(ByVal Prov1 As Integer, Prov2 As Integer) As Integer
        Dim ClimDif As Integer = 2

        If (Province(Prov1).Climate = 1 Or Province(Prov1).Climate = 2 Or Province(Prov1).Climate = 6 Or Province(Prov1).Climate = 10) And _
            (Province(Prov2).Climate = 1 Or Province(Prov2).Climate = 2 Or Province(Prov2).Climate = 6 Or Province(Prov2).Climate = 10) Then
            ClimDif = 0
        Else
            If (Province(Prov1).Climate = 3 Or Province(Prov1).Climate = 4 Or Province(Prov1).Climate = 7 Or Province(Prov1).Climate = 8) And _
                (Province(Prov2).Climate = 3 Or Province(Prov2).Climate = 4 Or Province(Prov2).Climate = 7 Or Province(Prov2).Climate = 8) Then
                ClimDif = 0
            End If
        End If

        Return ClimDif
    End Function

    Function GetCrowdedness(ByVal Prov As Integer) As Integer
        Dim HowCrowded As Integer = 0
        Dim RandTry As New Random

        HowCrowded = CInt(CDbl(Province(Prov).Peasants) / CDbl(Province(Prov).Farmland * Province(Prov).AgricultureLevel) * 10) - 4

        Return HowCrowded
    End Function
    Function GetLinguisticDif(ByVal Prov1 As Integer, Prov2 As Integer) As Integer
        Dim LingDif As Integer = 0

        If Province(Prov1).Language - Province(Prov2).Language > 0 Then
            If Math.Abs(Province(Prov1).Language - Province(Prov2).Language) < 10 Then
                LingDif = 1
            Else
                LingDif = 2
            End If
        End If

        Return LingDif
    End Function

    Public Sub CalcTurnRecAverages(ByVal TurnIdx As Integer)

        ' find averages of Weather and Pol. Control
        TurnRecord(TurnIdx).AverageWeather = Math.Round(TurnRecord(TurnIdx).AverageWeather / CDbl(TurnRecord(TurnIdx).ProvincesInFrance), 2)
        TurnRecord(TurnIdx).AgriLevel = Math.Round(TurnRecord(TurnIdx).AgriLevel / CDbl(TurnRecord(TurnIdx).ProvincesInFrance), 2)
        TurnRecord(TurnIdx).DegreeOfControl = Math.Round(TurnRecord(TurnIdx).DegreeOfControl / CDbl(TurnRecord(TurnIdx).ProvincesInFrance), 2)


    End Sub

    Public Sub AddProvInfoToTurnRec(ProvNm, TurnIdx)
        'Dim ProvWeather As Double

        TurnRecord(TurnIdx).ProvincesInFrance += 1
        TurnRecord(TurnIdx).NumPeasants += Province(ProvNm).Peasants
        TurnRecord(TurnIdx).NumNobles += Province(ProvNm).Nobles
        TurnRecord(TurnIdx).NumClergy += Province(ProvNm).Clergy
        TurnRecord(TurnIdx).NumTownspeople += Province(ProvNm).Townspeople
        TurnRecord(TurnIdx).TotalHarvest += Province(ProvNm).HarvestActual
        TurnRecord(TurnIdx).AverageWeather += WeatherByArea(Province(ProvNm).Climate) 'will need to be changed to average by divide by Prov when all done
        TurnRecord(TurnIdx).AgriLevel += Province(ProvNm).AgricultureLevel 'will need to be changed to average by divide by Prov when all done
        TurnRecord(TurnIdx).DegreeOfControl += Province(ProvNm).Loyalty 'ditto

    End Sub

    Public Sub UpdateTextboxes()


        If frmMapScreen.rbnPeasants.Checked = True Then
            frmMapScreen.rbnPeasants.Checked = False
            frmMapScreen.rbnPeasants.PerformClick()
        End If

        If frmMapScreen.rbnHarvest.Checked = True Then
            frmMapScreen.rbnHarvest.Checked = False
            frmMapScreen.rbnHarvest.PerformClick()
        End If

        If frmMapScreen.rbnNCT.Checked = True Then
            frmMapScreen.rbnNCT.Checked = False
            frmMapScreen.rbnNCT.PerformClick()
        End If

        If frmMapScreen.rbnAutonomy.Checked = True Then
            frmMapScreen.rbnAutonomy.Checked = False
            frmMapScreen.rbnAutonomy.PerformClick()
        End If

        If frmMapScreen.rbnWeather.Checked = True Then
            frmMapScreen.rbnWeather.Checked = False
            frmMapScreen.rbnWeather.PerformClick()
        End If

        If frmMapScreen.rbnSocialStateColor.Checked = True Then
            frmMapScreen.rbnSocialStateColor.Checked = False
            frmMapScreen.rbnSocialStateColor.PerformClick()
        End If

        If frmMapScreen.rbnAffiliation.Checked = True Then
            frmMapScreen.rbnAffiliation.Checked = False
            frmMapScreen.rbnAffiliation.PerformClick()
        End If


    End Sub

    Sub Migrate()
        Dim ProvinceNum As Integer = 0
        Dim PotentialTargetArea As Integer = -1
        Dim PotentialTarget As Integer = -1
        Dim CurrentTarget As Integer = -1
        Dim CurrentTargetValue As Integer = 0
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim k As Integer = 0
        Dim CoinFlip As Integer = 0
        Dim Rand As New Random
        Dim Strategy As Integer = 0
        Dim NeighboringSea As Integer = -1
        Dim TroopsToAdd As Integer = 0
        'Dim PopulationTransferred As Integer
        Dim TotalNewTroops As Integer = 0
        Dim NewTroopSources As Integer = 0
        Dim SourceProvinces() As Integer
        Dim MsgStr As String = ""

        Randomize()

        For ProvinceNum = 0 To TotalProvinces - 1

            If Province(ProvinceNum).SurplusPopulation > 0 Then
                'first see if internal migration within province will do the trick
                If Province(ProvinceNum).Peasants < (Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel) Then
                    Do
                        Province(ProvinceNum).SurplusPopulation -= 1
                        Province(ProvinceNum).Peasants += 1
                        Province(ProvinceNum).HarvestActual += 1
                    Loop Until (Province(ProvinceNum).SurplusPopulation = 0) Or (Province(ProvinceNum).Peasants = Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel)
                    ' changed to reduce internal migration in agric > 1 societies
                End If

                If Province(ProvinceNum).SurplusPopulation > 0 Then
                    If Province(ProvinceNum).PoliticalAffiliation = 0 Then
                        PotentialTarget = -1
                        CurrentTarget = -1
                        CurrentTargetValue = 0

                        For i = 0 To MAX_NEIGHBORS_LAND - 1 ' see if there's somewhere to move by land
                            If Province(ProvinceNum).Connectors(i) >= RIVER Then ' if neighbor is land connection
                                PotentialTargetArea = Province(ProvinceNum).Neighbors(i)
                                PotentialTarget = Area(PotentialTargetArea).Province
                                If (Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants) > CurrentTargetValue Then
                                    CurrentTarget = PotentialTarget
                                    CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                                Else
                                    If Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants = CurrentTargetValue Then
                                        CoinFlip = Rand.Next(0, 10) '2)
                                        If CoinFlip > 4 Then '= 1 Then
                                            CurrentTarget = PotentialTarget
                                            'CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                                        End If 'Coin flip says use the new one
                                    End If ' Neighbor is equal value to current 
                                End If ' Neighbor is better target than current
                            End If ' if Neighbor is land connection
                        Next ' i/Neighbor

                        If CurrentTarget = -1 Then 'if no land target found, check out by sea: current tech is only adjacent sea zone
                            For i = 0 To MAX_NEIGHBORS_LAND - 1
                                If Province(ProvinceNum).Connectors(i) = SEALANE Then
                                    PotentialTargetArea = Province(ProvinceNum).Neighbors(i)
                                    NeighboringSea = Area(PotentialTargetArea).Province
                                    If Sea(NeighboringSea).Topography = COASTAL Then 'will need to make this reflect maritime tech level eventually
                                        For j = 0 To MAX_NEIGHBORS_SEA - 1
                                            If Sea(NeighboringSea).Neighbors(j) >= 0 Then
                                                If Sea(NeighboringSea).Neighbors(j) <> ProvinceNum Then 'if not trying to invade itself
                                                    PotentialTargetArea = Sea(NeighboringSea).Neighbors(j)
                                                    'If Area(Sea(NeighboringSea).Neighbors(j)).Type = LAND Then
                                                    If Area(PotentialTargetArea).Type = LAND Then
                                                        PotentialTarget = Area(PotentialTargetArea).Province
                                                        If (Province(PotentialTarget).Farmland - Province(PotentialTarget).Peasants) > CurrentTargetValue Then
                                                            CurrentTarget = PotentialTarget
                                                            CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                                                        Else
                                                            If Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants = CurrentTargetValue Then
                                                                CoinFlip = Rand.Next(0, 10) '2)
                                                                If CoinFlip > 4 Then '= 1 Then
                                                                    CurrentTarget = PotentialTarget
                                                                    'CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                                                                End If 'Coin flip says use the new one
                                                            End If ' Neighbor is equal value to current 
                                                        End If ' Neighbor is better target than current
                                                    End If 'Neighbor to Sea Zone is a Land area
                                                End If 'not self 
                                                'Else ' if neighbor = -1, ie, no more neighbors 'no, testing Neighbors, not connections, so might be a sea area, with more land areas left to consider
                                                'Exit For
                                            End If ' Neighbor to sea zone exists
                                        Next 'Neigbor to Sea Zone
                                    End If 'isn't deep sea (ocean)
                                End If 'This is a Sea Connection
                            Next 'Neigbhor
                        End If 'No good targets by land

                        If CurrentTarget > -1 Then 'if a target was found

                            CoinFlip = Rand.Next(0, 10) '2) 'decide who wins by flip of coin for now.

                            If CoinFlip < 5 Then '= 1 Then
                                If Province(ProvinceNum).SurplusPopulation < CurrentTargetValue Then
                                    If CoinFlip < 5 Then '= 1 Then ' THis isn't necessary, since can only be her if CF < 5 !!
                                        If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(CurrentTarget).PoliticalAffiliation = PlayerSide Then
                                            MsgBox(CStr(Province(ProvinceNum).SurplusPopulation) & ",000 migrants from " & Province(ProvinceNum).Name & _
                                                   " have settled in " & Province(CurrentTarget).Name & ".")
                                        End If ' if player knows
                                        Province(CurrentTarget).Peasants += Province(ProvinceNum).SurplusPopulation
                                        Province(CurrentTarget).HarvestActual += Province(ProvinceNum).SurplusPopulation
                                        IncrementSocialState(ProvinceNum, BOOMING)
                                    Else ' this else is unnecessary; see comment above
                                        If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(CurrentTarget).PoliticalAffiliation = PlayerSide Then
                                            MsgBox("Migrants from " & Province(ProvinceNum).Name & " forced their way into " & Province(CurrentTarget).Name & ", killing " _
                                               & CStr(Province(ProvinceNum).SurplusPopulation \ 2) & ",000 inhabitants.")
                                        End If
                                        Province(CurrentTarget).Peasants += Province(ProvinceNum).SurplusPopulation \ 2
                                        DecrementSocialState(CurrentTarget, CHAOS)
                                        IncrementSocialState(ProvinceNum, BOOMING)
                                        Province(CurrentTarget).PoliticalAffiliation = Province(ProvinceNum).PoliticalAffiliation
                                        'Province(CurrentTarget).SocialState -=
                                    End If 'Coinflip = 1
                                Else
                                    If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(CurrentTarget).PoliticalAffiliation = PlayerSide Then
                                        MsgBox("Migrants from " & Province(ProvinceNum).Name & " forced their way into " & Province(CurrentTarget).Name & ", killing " _
                                                & CStr(Province(ProvinceNum).SurplusPopulation) & ",000 inhabitants.")
                                    End If
                                    DecrementSocialState(CurrentTarget, CHAOS)
                                    IncrementSocialState(ProvinceNum, BOOMING)
                                    Province(CurrentTarget).PoliticalAffiliation = Province(ProvinceNum).PoliticalAffiliation
                                End If ' Target can accomodate settlers
                            Else ' coinflip = 0
                                If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Or Province(CurrentTarget).PoliticalAffiliation = PlayerSide Then
                                    MsgBox("The inhabitants of " & Province(CurrentTarget).Name & " repelled invaders from " & Province(ProvinceNum).Name & ", killing " _
                                            & CStr(Province(ProvinceNum).SurplusPopulation) & ",000")
                                End If
                                'DecrementSocialState(ProvinceNum)
                            End If 'coinflip
                        Else ' no target
                            If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                                MsgBox("Famine in " & Province(ProvinceNum).Name & " has killed " & CStr(Province(ProvinceNum).SurplusPopulation) & ",000 people")
                            End If
                        End If ' no target
                        Province(ProvinceNum).SurplusPopulation = 0 ' one way or another, surplus pop is gone
                    Else 'is controlled by a government, and therefore surplus will join army instead of attack on own
                        TroopsToAdd = 0 ' 0 out the local variable from last province
                        TroopsToAdd = Province(ProvinceNum).SurplusPopulation \ WARRIOR_RATIO
                        If TroopsToAdd = 0 Then
                            TroopsToAdd = 1 'round up
                        End If

                        If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                            TotalNewTroops += TroopsToAdd
                            NewTroopSources += 1
                            ReDim Preserve SourceProvinces(NewTroopSources)
                            SourceProvinces(NewTroopSources - 1) = ProvinceNum
                        End If

                        Government(Province(ProvinceNum).PoliticalAffiliation).Infantry += TroopsToAdd
                        'Government(Province(ProvinceNum).PoliticalAffiliation).SurplusPop = True

                        '    If Province(ProvinceNum).PoliticalAffiliation = PlayerSide Then
                        '        MsgBox(CStr(TroopsToAdd) & ",000 Warriors from " & Province(ProvinceNum).Name _
                        '               & " have joined the " & Government(Province(ProvinceNum).PoliticalAffiliation).Name _
                        '               & " demanding conquests to provide land for their families.")
                        '    End If
                        'End If ' is an autonomous province

                    End If 'is an autonomous province
                End If 'Current province has suplus population not dealt with by internal migration
            End If ' Current Provincce has surplus population

        Next ' Province

        If TotalNewTroops > 0 Then
            frmMapScreen.rbnSurplusPopulation.PerformClick()
            'MsgBox(CStr(TroopsToAdd) & ",000 Warriors from " & Province(ProvinceNum).Name _
            '           & " have joined the " & Government(Province(ProvinceNum).PoliticalAffiliation).Name _
            '           & " demanding conquests to provide land for their families.")
            MsgStr = "A total of " & CStr(TotalNewTroops) & ",000 Warriors demanding Conquests to provide Land for their Families have joined your Army from "
            For i = 0 To NewTroopSources - 1
                If i > 0 Then
                    If NewTroopSources > 2 Then
                        MsgStr &= ", "
                    End If
                    If i = NewTroopSources - 1 Then
                        MsgStr &= "and "
                    End If
                End If
                Try
                    MsgStr &= Province(SourceProvinces(i)).Name
                Catch
                    MsgBox("ERROR: Problem with List of Provinces supplying Land hungry Warriors")
                End Try
            Next
            MsgStr &= "."
            MsgBox(MsgStr)
        End If

    End Sub

    Sub DecideIfNewTarget(ByVal PotentialTarget As Integer, ByVal ProvinceNum As Integer, CurrentTarget As Integer, CurrentTargetValue As Integer)
        Dim CoinFlip As Integer = 0
        Dim Rand As New Random

        If Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants > CurrentTargetValue Then
            CurrentTarget = PotentialTarget
            CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
        Else
            If Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants = CurrentTargetValue Then
                CoinFlip = Rand.Next(0, 1)
                If CoinFlip = 1 Then
                    CurrentTarget = PotentialTarget
                    CurrentTargetValue = Province(PotentialTarget).Farmland - Province(ProvinceNum).Peasants
                End If 'Coin flip says use the new one
            End If ' Neighbor is equal value to current 
        End If ' Neighbor is better target than current

    End Sub

    Sub DecrementSocialState(ByVal ProvinceNum As Integer, ByVal Floor As Integer)
        If Province(ProvinceNum).SocialState > Floor Then
            Province(ProvinceNum).SocialState -= 1
        End If
    End Sub

    Sub IncrementSocialState(ByVal ProvinceNum As Integer, ByVal Ceiling As Integer)
        If Province(ProvinceNum).SocialState < Ceiling Then
            Province(ProvinceNum).SocialState += 1
        End If
    End Sub

    Sub AdvanceDate()
        'Dim OldDate, NewDate As Integer

        'OldDate = CInt(frmMapScreen.lblDate.Text.Substring(0, 4))
        TurnDate += TURN_INTERVAL
        TurnNum += 1

        frmMapScreen.lblDate.Text = DATE_LBL_BASE & CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL) & " C.E."

    End Sub

    Sub Sufferplague(ByVal ProvNum As Integer, ByVal Wave As Integer)
        Dim PeasToLand As Integer = 1
        Dim i As Integer = 0
        'Dim TowniesPre As Integer = Province(ProvNum).Townspeople
        'Dim NoblesPre As Integer = Province(ProvNum).Nobles
        'Dim ClergyPre As Integer = Province(ProvNum).Clergy
        'Dim PeasPre As Integer = Province(ProvNum).Peasants
        'Dim TotalPre As Integer = 0
        'Dim TotalPost As Integer = 0
        'Dim TotalDead As Integer = 0
        'Dim DeadPercent As Integer = 0
        Dim NumDecrements As Integer = 0

        'TotalPre += TowniesPre + NoblesPre + ClergyPre + PeasPre

        Province(ProvNum).Townspeople -= Province(ProvNum).Townspeople \ (1 + Wave) '(2 * Wave)
        Province(ProvNum).Nobles = 2 * Province(ProvNum).Nobles \ 3
        'If Province(ProvNum).Nobles < 1 Then
        '    Province(ProvNum).Nobles = 1
        'End If
        Province(ProvNum).Clergy -= Province(ProvNum).Clergy \ (1 + Wave) '(2 * Wave)
        PeasToLand = Province(ProvNum).Farmland \ Province(ProvNum).Peasants
        If PeasToLand < 1 Then PeasToLand = 1
        Province(ProvNum).Peasants -= (Province(ProvNum).Peasants) \ (PeasToLand + Wave + 1) '2)

        'TotalPost += Province(ProvNum).Townspeople + Province(ProvNum).Nobles + Province(ProvNum).Clergy + Province(ProvNum).Peasants
        'TotalDead = TotalPre - TotalPost
        'DeadPercent = CInt((CDec(TotalDead) / CDec(TotalPre)) * 100)

        NumDecrements = 4 - PeasToLand - Wave
        If NumDecrements > 0 Then
            For i = 1 To NumDecrements
                DecrementSocialState(ProvNum, CHAOS)
            Next
        End If
        'If Province(ProvNum).PoliticalAffiliation = PlayerSide Then
        '    MsgBox("Plague Hits " & Province(ProvNum).Name & "!" & vbCrLf & vbCrLf _
        '           & CStr(TotalDead) & ",000 out of " & CStr(TotalPre) & ",000 of the inhabitants have died!")
        'End If

        'Province(ProvinceNum).Peasants -= CInt((CDec(Province(ProvinceNum).Peasants) / CDec(Province(ProvinceNum).Farmland * 2) * CDec(Province(ProvinceNum).Peasants)))

    End Sub



    Sub DetermineWeather()
        Dim Zone As Integer = 0
        Dim Weather As Integer = 0
        Dim DieRoll As Integer = 0
        'Dim RandomNum As Integer = 0
        Dim Rand As New Random
        Dim DieRoll1, DieRoll2 As Integer
        Dim Century As Integer = 0
        Dim SpecialWeather As Integer = -1
        'frmMapScreen.rbnWeather.Checked = True
        Dim ExtremeAreas As Integer = 0
        Dim ExtremeArea() As Integer
        Dim MsgStr As String = ""
        Dim i As Integer = 0
        Dim ExtremeBad As Integer = 0
        Dim ExtremeGood As Integer = 0


        Century = (TurnDate \ 100) + 1

        Randomize()

        For Zone = 1 To CLIMATE_ZONES - 1 ' "Zone 0" = areas outside Europe

            Select Case Century
                Case 5
                    DieRoll = 0
                Case 6
                    DieRoll = -1
                Case 7
                    DieRoll = -2
                Case 8
                    DieRoll = -1
                Case 9
                    DieRoll = 0
                Case 10
                    DieRoll = 0
                Case 11
                    DieRoll = 1
                Case 12
                    DieRoll = 2
                Case 13
                    DieRoll = 2
                Case 14
                    DieRoll = 1
                Case 15
                    DieRoll = 0
                Case 16
                    DieRoll = -1
                Case 17
                    DieRoll = -2
                Case 18
                    DieRoll = -1
                Case 19
                    DieRoll = 0
                Case 20
                    DieRoll = 1
                Case 21
                    DieRoll = 2
            End Select

            DieRoll1 = Rand.Next(1, 7) 'comment out TEMPORARILY to make it easier to see socioeconomic trends without randomized influence
            Select Case TurnDate
                Case 650, 1300, 1650, 2000
                    Select Case DieRoll1
                        Case 1, 2
                            WeatherByArea(Zone) = TERRIBLE_WEATHER
                        Case 3, 4, 5
                            WeatherByArea(Zone) = BAD_WEATHER
                        Case 6
                            WeatherByArea(Zone) = NORMAL_WEATHER
                    End Select
                Case Else
                    DieRoll2 = Rand.Next(1, 7)
                    'DieRoll1 = 7
                    'DieRoll2 = 7

                    DieRoll += DieRoll1 + DieRoll2

                    'If TurnDate = 480 Then
                    '    If Zone = 1 Or Zone = 2 Or Zone = 3 Or Zone = 5 Or Zone = 10 Then
                    '        DieRoll = 7
                    '    End If
                    'End If

                    Select Case DieRoll
                        Case 14, 1
                            WeatherByArea(Zone) = TERRIBLE_WEATHER
                            'MsgBox("Terrible Weather in Climate Zone " & CStr(i))
                        Case 2, 3
                            WeatherByArea(Zone) = BAD_WEATHER
                            'MsgBox("Bad Weather in Climate Zone " & CStr(i))
                        Case 11, 12
                            WeatherByArea(Zone) = GOOD_WEATHER
                            'MsgBox("Good Weather in Climate Zone " & CStr(i))
                        Case 13, 0
                            WeatherByArea(Zone) = GREAT_WEATHER
                            'MsgBox("Great Weather in Climate Zone " & CStr(i))
                        Case Else
                            WeatherByArea(Zone) = NORMAL_WEATHER
                    End Select
            End Select

            If WeatherByArea(Zone) <> NORMAL_WEATHER Then
                'Weather = WeatherByArea(Zone)
                ExtremeAreas += 1
                ReDim Preserve ExtremeArea(ExtremeAreas)
                ExtremeArea(ExtremeAreas - 1) = Zone
                'MsgBox(NameWeather(Weather) & " Weather in " & NameClimateZone(Zone) & " Zone.")
                'frmMapScreen.Refresh()
            End If
        Next

        frmMapScreen.rbnWeather.PerformClick()

        'If ExtremeAreas > 0 Then ' *** Turned of for db Development
        '    For i = 0 To ExtremeAreas - 1
        '        Try
        '            If WeatherByArea(ExtremeArea(i)) < 0 Then
        '                If ExtremeBad = 0 Then
        '                    MsgStr = "UNUSUAL WEATHER PATTERNS: " & CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL) & DOUBLE_SPACE
        '                    MsgStr &= "Bad Weather prevails in: "
        '                End If
        '                ExtremeBad += 1
        '                If ExtremeBad > 1 Then
        '                    MsgStr &= ", "
        '                End If
        '                MsgStr &= NameClimateZone(ExtremeArea(i))
        '            End If
        '        Catch
        '            MsgBox("ERROR: Problem with List of Provinces Areas with Bad Weather")
        '        End Try
        '    Next
        '    If ExtremeBad < ExtremeAreas Then
        '        If ExtremeBad <> 0 Then
        '            MsgStr &= DOUBLE_SPACE
        '        Else ' if only good weather
        '            MsgStr = "UNUSUAL WEATHER PATTERNS: " & CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL) & DOUBLE_SPACE
        '        End If
        '        MsgStr &= "Good Weather prevails in: "
        '        For i = 0 To ExtremeAreas - 1
        '            Try
        '                If WeatherByArea(ExtremeArea(i)) > 0 Then
        '                    ExtremeGood += 1
        '                    If ExtremeGood > 1 Then
        '                        MsgStr &= ", "
        '                    End If
        '                    MsgStr &= NameClimateZone(ExtremeArea(i))
        '                End If
        '            Catch
        '                MsgBox("ERROR: Problem with List of Provinces Areas with Good Weather")
        '            End Try
        '        Next
        '    End If
        '    MsgBox(MsgStr, MsgBoxStyle.OkOnly, CStr(TURN_INTERVAL) & " Year Weather Patterns")
        'Else
        '    MsgBox("Weather Patterns Normal Throughout Europe from " & CStr(TurnDate) & " to " & CStr(TurnDate + TURN_INTERVAL) & ".", MsgBoxStyle.OkOnly, CStr(TURN_INTERVAL) & " Year Weather Patterns")
        'End If
        'MsgBox(NameWeather(Weather) & " Weather in " & NameClimateZone(Zone) & " Zone.")


    End Sub


    Sub PopulationGrowth(ProvinceNum As Integer)
        Dim OldSOL As Integer = 0
        Dim Reprorate As Decimal
        Dim PopIncrease As Integer = 0
        Dim i As Integer = 0
        ' = 0.03

        OldSOL = 3

        OldSOL += Province(ProvinceNum).AgricultureLevel

        ' Note: Agric level multiplier in both if ... then and in formula added 7/25/13
        'If Province(ProvinceNum).Peasants < (3 * Province(ProvinceNum).Farmland \ 4) * Province(ProvinceNum).AgricultureLevel Then
        OldSOL += (Province(ProvinceNum).Farmland * Province(ProvinceNum).AgricultureLevel) \ Province(ProvinceNum).Peasants
        'End If

        OldSOL = OldSOL + WeatherByArea(Province(ProvinceNum).Climate)

        'OldSOL = OldSOL + Province(ProvinceNum).SocialState

        Reprorate = 0.01 * OldSOL '.03 per 20 years appears to be average 500=1340

        PopIncrease = Int(Province(ProvinceNum).Peasants * Reprorate) 'Int used instead of CInt to truncate rather than round (so .5 goes down, not up)

        Province(ProvinceNum).Peasants += PopIncrease

        'NEED A BETTER WAY TO ACCOUNT FOR RELATIONSHIP OF PEASANT POPULATION GROWTH AND GROWTH OF NOBLE & CLERGY POPS AND DISTRIBUTION OF LAND
        'If (Province(ProvinceNum).Peasants / PEASANTS_PER_BENEFICE) - (Province(ProvinceNum).Nobles + Province(ProvinceNum).Clergy) > 0 Then
        '    If Province(ProvinceNum).Nobles > 0 Then
        '        Province(ProvinceNum).Nobles()
        '    End If
        'End If

        'If Province(ProvinceNum).Nobles < Province(ProvinceNum).Peasants \ 50 Then
        '    Province(ProvinceNum).Nobles = Province(ProvinceNum).Peasants \ 50
        'End If

        'If Province(ProvinceNum).Clergy < Province(ProvinceNum).Peasants \ 50 Then
        '    Province(ProvinceNum).Clergy = Province(ProvinceNum).Peasants \ 50
        'End If

        'If Province(ProvinceNum).Townspeople < Province(ProvinceNum).Nobles \ 2 Then
        '    Province(ProvinceNum).Townspeople = Province(ProvinceNum).Nobles \ 2
        'End If

    End Sub

    Sub SetUpAvars(GovNum)
        Dim i As Integer = 0

        Government(GovNum).Name = AVARS_STR '"Avars" 'Note that this Replaces None
        Government(GovNum).Infantry = 0
        Government(GovNum).Cavalary = 300
        Government(GovNum).Language = TURKIC
        Government(GovNum).Religion = PAGAN
        Government(GovNum).Generalship = GENIUS
        Government(GovNum).ArmyState = FANATICAL
        Government(GovNum).LeadershipState = VIGOROUS
        Government(GovNum).PoliticalSavvy = TALENTED
        Government(GovNum).RoyalEstates = 0
        Government(GovNum).Support = ENTHUSIASTIC
        Government(GovNum).Treasury = 0
        Government(GovNum).TotalBenefices = 0

        For i = 0 To TotalGovernments - 1
            Government(GovNum).DiplomaticRelations(i) = HOSTILE
        Next

        For i = 0 To TotalProvinces - 1
            If Province(i).ID = "Russia" Or Province(i).Name = "Poland" Then
                Province(i).SocialState = ORDERLY
                Province(i).PoliticalAffiliation = GovNum
                Province(i).Peasants += 50
                Province(i).Nobles = 5
            Else
                If Province(i).Name = "E.Germany" Or Province(i).Name = "Balkans" Then
                    Province(i).SocialState = DISORDER
                End If
            End If
        Next
        frmMapScreen.Refresh()
    End Sub

    Sub SetUpSeljuks(GovNum)
        Dim i As Integer = 0

        ' this simplifed to avoid suspected crash bug

        'Government(GovNum).Name = SELJUK_STR '"Avars" 'Note that this Replaces None
        'Government(GovNum).Infantry = 0
        'Government(GovNum).Cavalary = 300
        'Government(GovNum).Language = TURKIC
        'Government(GovNum).Religion = MUSLIM
        'Government(GovNum).Generalship = TALENTED
        'Government(GovNum).ArmyState = FANATICAL
        'Government(GovNum).LeadershipState = VIGOROUS
        'Government(GovNum).PoliticalSavvy = TALENTED
        'Government(GovNum).AdminAbility = TALENTED
        'Government(GovNum).RoyalEstates = 0
        'Government(GovNum).Support = ENTHUSIASTIC
        'Government(GovNum).Treasury = 0
        'Government(GovNum).TotalBenefices = 0

        'For i = 0 To TotalGovernments - 1
        '    Government(GovNum).DiplomaticRelations(i) = HOSTILE
        'Next

        For i = 62 To 63 '0 To TotalProvinces - 1
            'If Province(i).ID = 62 Or Province(i).ID = 63 Then
            Province(i).SocialState = ORDERLY
            Province(i).PoliticalAffiliation = LOCAL_CONTROL 'GovNum
            Province(i).ControlLevel = INDEPENDENT 'SUBORDINATE
            Province(i).Loyalty = ENTHUSIASTIC
            'Province(i).Peasants += 50
            'Province(i).Nobles = 5
            'Else
            '    If Province(i).Name = "E.Germany" Or Province(i).Name = "Balkans" Then
            '        Province(i).SocialState = DISORDER
            'End If
        Next

        frmMapScreen.Refresh()
    End Sub

    Sub BeginTurn()
        Dim Decision As MsgBoxResult = MsgBoxResult.Yes
        Dim Msgstr As String = ""

        AdvanceDate()
        DetermineLeadershipStates()


        DoSocioeconomicChange()
        CalcGovernmentResources()
        NewPeoples()

        PopulateTurnDisplay(TurnNum)

        'Try
        '    SaveTurnRecords(PLAYER_SAVE)
        'Catch
        '    MsgBox("Problem Saving Turn Records in Begin Turn")
        'End Try

         frmBeginTurn.ShowDialog()

        If WorksheetGame = True Then
            If TurnNum Mod (100 \ TURN_INTERVAL) = 0 Then
                PlayerAction = DOING_WORKSHEET

                ActionPhase = SOCIOECONOMIC_TRENDS_QUESTION

                SocioecoCombosDone = False ' so they'll be set up on first opening of form

                'ReDim Preserve WorksheetScore.SocioeconomicQuestion((TurnNum \ (100 \ TURN_INTERVAL)) - 1) ' put in initialization of record

                Do
                    WorksheetTask = SHOW_WORKSHEET
                    frmCenturyWorksheet.ShowDialog()
                    ' SocioecoCombosDone = True ' This is set in form itself once they're set up

                    If WorksheetTask = SHOW_GRAPH Then
                        frmBeginTurn.ShowDialog()
                    End If

                Loop Until (WorksheetTask = END_WORKSHEET)
                'Else
                '    frmBeginTurn.ShowDialog()
                SocioecoCombosDone = False ' reset this just in case worksheet called from elsewherew
            End If
        End If

        CurrentAction = 0 ' moved from frmBeginTurn_FormClosed so can call frmBeginTurn without wacking up order of play
        PlayerAction = NO_ACTION
        ActionPhase = NO_ACTION
        TotalActions = CreateActionQueue()

        AutoTurn()


    End Sub


End Module
