﻿Imports System.Windows.Forms.DataVisualization.Charting

Public Class frmBeginTurn

    Dim TurnShowing As Integer = 0

    Private Sub frmBeginTurn_Click(sender As Object, e As System.EventArgs) Handles Me.Click
        'Me.Hide()
        'Me.Close()

    End Sub

    Private Sub frmBeginTurn_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'CurrentAction = 0 ' *** Turned off for db development
        'TotalActions = CreateActionQueue()

        'AutoTurn()

    End Sub

    Private Sub frmBeginTurn_Load(sender As Object, e As System.EventArgs) Handles Me.Load

        'AdvanceDate()
        'DetermineLeadershipStates() 'These moved to BeginTurn()

        'lblDate.Text = TurnDate & " A.D."
        'lblLeadership.Text = "Leadership: " & DescribeGovernmentState(Government(PlayerSide).LeadershipState)
        'lblArmyState.Text = "Army: " & DescribeArmyState(Government(PlayerSide).ArmyState)
        'lblWealth.Text = "Treasury: " & CStr(Government(PlayerSide).Treasury)

        txtDateDisplayed.Text = CStr(TurnDate + TURN_INTERVAL)
        lblTitle.Text = "Socioeconomic Trends and Leadership Resources " & CStr(ScenarioStartDate) & " - " & CStr(TurnDate + TURN_INTERVAL)
        lblSubtitle.Text = "Current Turn " & CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL)

        lblYears.Text = CStr(TurnDate) & " - " & CStr(TurnDate + TURN_INTERVAL)
        lblLeadership.Text = "Government: " & DescribeGovernmentState(Government(PlayerSide).LeadershipState)
        lblGeneralship.Text = "Generalship: " & GetAbilityNames(Government(PlayerSide).Generalship)
        lblAdminAbility.Text = "Administrative Ability: " & GetAbilityNames(Government(PlayerSide).AdminAbility)
        lblPoliticalSavvy.Text = "Political Savvy: " & GetAbilityNames(Government(PlayerSide).PoliticalSavvy)
        lblRefinement.Text = "Cultural Refinement: " & GetAbilityNames(Government(PlayerSide).Refinement)
        lblArmyState.Text = "Army State: " & DescribeArmyState(Government(PlayerSide).ArmyState)
        lblWealth.Text = "Treasury: " & CStr(Government(PlayerSide).Treasury) & ",000 " & CurrencyStr

        'DoSocioeconomicChange()
        'CalcGovernmentResources() 'These too
        'NewPeoples()

        'PopulateTurnDisplay()

        DoSocioEcoGraph(False) 'False means Not Refreshing, so preselected checkboxes will be displayed by default 'Needed? or just default the defauts to on?

        btnClose.Focus()

        'If WorksheetGame = True Then
        '    btnWorksheet.Visible = True
        'End If


    End Sub

    Private Sub lblDate_Click(sender As System.Object, e As System.EventArgs) Handles lblSelectAndDeselect.Click
        Me.Hide()
        Me.Close()

    End Sub

    Private Sub lblAD_Click(sender As System.Object, e As System.EventArgs)
        'Me.Hide()
        'Me.Close()

    End Sub

    Private Sub lblContinue_Click(sender As System.Object, e As System.EventArgs) Handles lblContinue.Click
        'Me.Hide()
        'Me.Close()

    End Sub

    Private Sub Close_Click(sender As System.Object, e As System.EventArgs) Handles btnClose.Click
        Me.Hide()
        Me.Close()
    End Sub

    Private Sub lblLeadership_Click(sender As System.Object, e As System.EventArgs) Handles lblLeadership.Click
        'Me.Hide()
        'Me.Close()

    End Sub

    Private Sub lblPlayerStatelbl_Click(sender As System.Object, e As System.EventArgs) Handles lblPlayerStatelbl.Click
        'Me.Hide()
        'Me.Close()

    End Sub

    Private Sub lblArmyState_Click(sender As System.Object, e As System.EventArgs) Handles lblArmyState.Click
        'Me.Hide()
        'Me.Close()

    End Sub

    Private Sub lblWealth_Click(sender As System.Object, e As System.EventArgs) Handles lblWealth.Click
        'Me.Hide()
        'Me.Close()

    End Sub

    Sub DoSocioEcoGraph(ByVal Refreshing As Boolean) ' maybe not needed
        'Dim crtSocioEcoGraph1 As New Chart
        'Create new series and add data points to them
        Dim i As Integer = 0
        Dim WeatherData As New Series
        Dim PeasantData As New Series
        Dim AgriLevelData As New Series
        Dim HarvestData As New Series
        Dim NobleData As New Series
        Dim ClergyData As New Series
        Dim TownspeopleData As New Series
        Dim TradeData As New Series
        Dim ManufacturingData As New Series
        Dim VagrantsData As New Series
        Dim ProvincesData As New Series
        Dim ControlData As New Series
        Dim TaxData As New Series
        Dim DateToShow As Integer = 0

        crtSocioEcoGraph.Series.Clear()
        'crtSocioEcoGraph2.Series.Clear()
        'crtSocioEcoGraph = crtSocioEcoGraph

        'crtSocioEcoGraph.t()
        'If Refreshing <> True Then
        '    crtSocioEcoGraph.Titles.Add("Socioeconomic Trends")
        '    'crtSocioEcoGraph2.Titles.Add("Socioeconomic Trends 2")
        'End If

        WeatherData.Name = "Weather"
        PeasantData.Name = "Peasants"
        AgriLevelData.Name = "Agricultural Level"
        HarvestData.Name = "Harvest"
        NobleData.Name = "Nobles"
        ClergyData.Name = "Clergy"
        TownspeopleData.Name = "Townfolk"
        TradeData.Name = "Trade"
        ManufacturingData.Name = "Manufacture"
        VagrantsData.Name = "Vagrants"
        ProvincesData.Name = "Provinces"
        ControlData.Name = "Control"
        TaxData.Name = "Taxes"

        WeatherData.ChartType = SeriesChartType.Line
        PeasantData.ChartType = SeriesChartType.Line
        AgriLevelData.ChartType = SeriesChartType.Line
        HarvestData.ChartType = SeriesChartType.Line
        NobleData.ChartType = SeriesChartType.Line
        ClergyData.ChartType = SeriesChartType.Line
        TownspeopleData.ChartType = SeriesChartType.Line
        TradeData.ChartType = SeriesChartType.Line
        ManufacturingData.ChartType = SeriesChartType.Line
        VagrantsData.ChartType = SeriesChartType.Line
        ProvincesData.ChartType = SeriesChartType.Line
        ControlData.ChartType = SeriesChartType.Line
        TaxData.ChartType = SeriesChartType.Line

        WeatherData.MarkerStyle = MarkerStyle.Star10
        PeasantData.MarkerStyle = MarkerStyle.Square
        PeasantData.MarkerStyle = MarkerStyle.Triangle
        HarvestData.MarkerStyle = MarkerStyle.Diamond
        NobleData.MarkerStyle = MarkerStyle.Cross
        ClergyData.MarkerStyle = MarkerStyle.Circle
        TownspeopleData.MarkerStyle = MarkerStyle.Triangle
        TradeData.MarkerStyle = MarkerStyle.Square
        ManufacturingData.MarkerStyle = MarkerStyle.Cross
        VagrantsData.MarkerStyle = MarkerStyle.Star4
        ProvincesData.MarkerStyle = MarkerStyle.Triangle
        ControlData.MarkerStyle = MarkerStyle.Star4
        TaxData.MarkerStyle = MarkerStyle.Diamond

        WeatherData.IsValueShownAsLabel = True
        ControlData.IsValueShownAsLabel = True
        AgriLevelData.IsValueShownAsLabel = True

        For i = 0 To TurnNum    ' - 1   ' not needed because "Turn 0" is baseline calculated on startup
            DateToShow = ScenarioStartDate + (TURN_INTERVAL * i) ' adjusts for fact that Turn 0 = before scenario start
            WeatherData.Points.AddXY(DateToShow, TurnRecord(i).AverageWeather)
            PeasantData.Points.AddXY(DateToShow, TurnRecord(i).NumPeasants)
            AgriLevelData.Points.AddXY(DateToShow, TurnRecord(i).AgriLevel)
            HarvestData.Points.AddXY(DateToShow, TurnRecord(i).TotalHarvest)
            NobleData.Points.AddXY(DateToShow, TurnRecord(i).NumNobles)
            ClergyData.Points.AddXY(DateToShow, TurnRecord(i).NumClergy)
            TownspeopleData.Points.AddXY(DateToShow, TurnRecord(i).NumTownspeople)
            TradeData.Points.AddXY(DateToShow, TurnRecord(i).TotalTrade)
            ManufacturingData.Points.AddXY(DateToShow, TurnRecord(i).TotalManufacture)
            VagrantsData.Points.AddXY(DateToShow, TurnRecord(i).NumSurplus)
            ProvincesData.Points.AddXY(DateToShow, TurnRecord(i).ProvincesInFrance)
            ControlData.Points.AddXY(DateToShow, Math.Round(TurnRecord(i).DegreeOfControl, 2))
            TaxData.Points.AddXY(DateToShow, TurnRecord(i).TaxIncome)
        Next
        'Peas.Points.AddXY("1991", 15)
        'Peas.Points.AddXY("1992", 17)
        'Add the series to the Chart1 control

        'If Refreshing = False Then
        '    cbxWeather.Checked = True
        '    cbxPeasants.Checked = True
        '    cbxHarvest.Checked = True
        'End If

        If cbxWeather.Checked = True Then
            crtSocioEcoGraph.Series.Add(WeatherData)
        End If
        If cbxPeasants.Checked = True Then
            crtSocioEcoGraph.Series.Add(PeasantData)
        End If
        If cbxAgriLevel.Checked = True Then
            crtSocioEcoGraph.Series.Add(AgriLevelData)
        End If
        If cbxHarvest.Checked = True Then
            crtSocioEcoGraph.Series.Add(HarvestData)
        End If
        If cbxNobles.Checked = True Then
            crtSocioEcoGraph.Series.Add(NobleData)
        End If
        If cbxClergy.Checked = True Then
            crtSocioEcoGraph.Series.Add(ClergyData)
        End If
        If cbxTownspeople.Checked = True Then
            crtSocioEcoGraph.Series.Add(TownspeopleData)
        End If
        If cbxTrade.Checked = True Then
            crtSocioEcoGraph.Series.Add(TradeData)
        End If
        If cbxManfuacture.Checked = True Then
            crtSocioEcoGraph.Series.Add(ManufacturingData)
        End If
        If cbxVagrants.Checked = True Then
            crtSocioEcoGraph.Series.Add(VagrantsData)
        End If
        If cbxProvinces.Checked = True Then
            crtSocioEcoGraph.Series.Add(ProvincesData)
        End If
        If cbxControl.Checked = True Then
            crtSocioEcoGraph.Series.Add(ControlData)
        End If
        If cbxTaxes.Checked = True Then
            crtSocioEcoGraph.Series.Add(TaxData)
        End If

        crtSocioEcoGraph.ResetAutoValues()
        'crtSocioEcoGraph2.ResetAutoValues()
        'crtSocioEcoGraph.Update()

        crtSocioEcoGraph.ChartAreas(0).AxisY.ScaleBreakStyle.Enabled = True
        crtSocioEcoGraph.ChartAreas(0).AxisY.ScaleBreakStyle.MaxNumberOfBreaks = 3
        crtSocioEcoGraph.ChartAreas(0).AxisY.ScaleBreakStyle.BreakLineStyle = BreakLineStyle.Wave

        crtSocioEcoGraph.ChartAreas(0).AxisX.Minimum = ScenarioStartDate
        crtSocioEcoGraph.ChartAreas(0).AxisX.Maximum = ScenarioStartDate + (TURN_INTERVAL * (TurnNum))


        TurnShowing = TurnNum 'This is to set up Previous and Next button mechanisms

    End Sub


    Private Sub Chart1_Click(sender As System.Object, e As System.EventArgs) Handles crtSocioEcoGraph.Click

    End Sub

    Private Sub btnRefresh_Click(sender As Object, e As System.EventArgs) Handles btnRefresh.Click

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub btnNext_Click(sender As System.Object, e As System.EventArgs) Handles btnNext.Click
        Dim DateInt As Integer = 0
        Dim TurnToShow As Integer = 0

        DateInt = CInt(txtDateDisplayed.Text)
        'TurnToShow = TurnNum - ((DateInt - ScenarioStartDate - TURN_INTERVAL) \ TURN_INTERVAL)
        TurnToShow = TurnShowing + 1

        If TurnToShow <= TurnNum Then
            txtDateDisplayed.Text = CStr(DateInt + TURN_INTERVAL)
            PopulateTurnDisplay(TurnToShow)
            TurnShowing = TurnToShow
        End If

    End Sub

    Private Sub btnLast_Click(sender As System.Object, e As System.EventArgs) Handles btnLast.Click
        Dim DateInt As Integer = 0
        'Dim TurnShowing As Integer = 0
        Dim TurnToShow As Integer = 0

        DateInt = CInt(txtDateDisplayed.Text)
        'TurnShowing = TurnNum - (DateInt - (ScenarioStartDate - TURN_INTERVAL)) \ TURN_INTERVAL
        TurnToShow = TurnShowing - 1

        If TurnToShow >= 0 Then
            txtDateDisplayed.Text = CStr(DateInt - TURN_INTERVAL)
            PopulateTurnDisplay(TurnToShow)
            TurnShowing = TurnToShow
        End If
    End Sub

    Private Sub cbxWeather_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxWeather.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxPeasants_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxPeasants.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxAgriLevel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxAgriLevel.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxHarvest_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxHarvest.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxNobles_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxNobles.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxClergy_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxClergy.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxTownspeople_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxTownspeople.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxTrade_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxTrade.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxManfuacture_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxManfuacture.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxVagrants_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxVagrants.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxProvinces_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxProvinces.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxControl_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxControl.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

    Private Sub cbxTaxes_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbxTaxes.CheckedChanged

        DoSocioEcoGraph(True) 'True means is refreshing

    End Sub

End Class