﻿
Public Class frmProvinceInfo

    Dim TextboxChanged As Boolean = False
    Dim RecordChanged As Boolean = False

    Private Sub lblPeasants_Click(sender As System.Object, e As System.EventArgs) Handles lblPeasants.Click

    End Sub

    Private Sub TextBox5_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtSurplusPop.TextChanged
        TextboxChanged = True
    End Sub

    Private Sub txtAgriculturalLevel_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtAgriculturalLevel.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtPeasants_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtPeasants.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtFarmland_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtFarmland.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtTotalland_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtPoliticalAffiliation.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub btnCloseProvinceInfo_Click(sender As System.Object, e As System.EventArgs) Handles btnCloseProvinceInfo.Click
        'Province(ProvinceNum).Name = frmProvinceInfo.tx
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        If RecordChanged = True Then
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        Close()

    End Sub

    Private Sub frmProvinceInfo_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        PopulateProvinceDisplay(SelectedArea)
        ColorTextboxes(SelectedArea)
        TextboxChanged = False
        RecordChanged = False

        If Playing = vbYes Then
            Me.btnRecord.Hide()
            Me.btnRestoreData.Hide()
            Me.btnSave.Hide()
        End If

    End Sub

    Private Sub Label3_Click(sender As System.Object, e As System.EventArgs) Handles lblAreaID.Click

    End Sub

    Private Sub btnNextProvince_Click(sender As System.Object, e As System.EventArgs) Handles btnNextProvince.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            'If RecordChanged = False Then ' whenver Record Changes, Textbox change set to false, so this test shouldn't be needed.
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
            'End If
        End If

        If SelectedArea < TotalProvinces - 1 Then
            SelectedArea += 1
        Else
            SelectedArea = 0
        End If

        PopulateProvinceDisplay(SelectedArea) '(Area(SelectedArea).Province)
        ColorTextboxes(SelectedArea)
        TextboxChanged = False

        Me.Refresh()

    End Sub

    Private Sub btnPreviousProvince_Click(sender As System.Object, e As System.EventArgs) Handles btnPreviousProvince.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = True Then
            'If RecordChanged = False Then 'see above
            MsgBoxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
            'End If
        End If

        If SelectedArea > 0 Then
            SelectedArea -= 1
        Else
            SelectedArea = TotalProvinces - 1
        End If

        PopulateProvinceDisplay(SelectedArea) '(Area(SelectedArea).Province)
        ColorTextboxes(SelectedArea)
        TextboxChanged = False

        Me.Refresh()

    End Sub

    Private Sub btnSave_Click(sender As System.Object, e As System.EventArgs) Handles btnSave.Click
        Dim MsgBoxResult As Microsoft.VisualBasic.MsgBoxResult

        If RecordChanged = False Then
            MsgBox("No Information Updated; No reason to Save")
            Exit Sub
        End If

        If TextboxChanged = True Then
            MsgBox("Recent Change(s) Unrecorded. Save Without Them?", MsgBoxStyle.YesNo, "Failsafe")
            If MsgBoxResult = vbNo Then
                Exit Sub
            End If
        End If

        MsgBoxResult = MsgBox("Update Permanent Record?", MsgBoxStyle.YesNo, "Failsafe")
        If MsgBoxResult = vbYes Then
            SaveProvinces(PLAYER_SAVE)
            RecordChanged = False
        End If


    End Sub

    Private Sub txtTopgraphy_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtTopgraphy.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtClimate_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtClimate.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtHarvestActual_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtHarvestActual.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub btnRecord_Click(sender As System.Object, e As System.EventArgs) Handles btnRecord.Click

        'So can Backup existing values in case of problem
        Dim Cl, Lo, Re, No, La, Af, Su, Pe, Al, Hv, Fl, Tp, Fo, Fa, Cv, Ad, Ct, TL, NV As Integer
        Cl = Province(SelectedArea).Clergy
        Lo = Province(SelectedArea).Loyalty
        Re = Province(SelectedArea).Religion
        No = Province(SelectedArea).Nobles
        La = Province(SelectedArea).Language
        Af = Province(SelectedArea).PoliticalAffiliation
        Su = Province(SelectedArea).SurplusPopulation
        Pe = Province(SelectedArea).Peasants
        Al = Province(SelectedArea).AgricultureLevel
        Hv = Province(SelectedArea).HarvestActual
        Fl = Province(SelectedArea).Farmland
        Tp = Province(SelectedArea).Townspeople
        Cv = Province(SelectedArea).ControlLevel
        Ad = Province(SelectedArea).AdminLevel
        Ct = Province(SelectedArea).TownCharters
        TL = Province(SelectedArea).TradeLevel
        NV = Province(SelectedArea).NavalValue



        If TextboxChanged = False Then
            MsgBox("No Information Updated; No reason to Record")
            Exit Sub
        End If


        Try
            Province(SelectedArea).Language = CInt(Me.txtLanguage.Text)
            Province(SelectedArea).Loyalty = CInt(Me.txtLoyalty.Text)
            Province(SelectedArea).Religion = CInt(Me.txtReligion.Text)
            Province(SelectedArea).Nobles = CInt(Me.txtNobles.Text)
            Province(SelectedArea).Clergy = CInt(Me.txtClergy.Text)
            Province(SelectedArea).PoliticalAffiliation = CInt(Me.txtPoliticalAffiliation.Text)
            Province(SelectedArea).AgricultureLevel = CInt(Me.txtAgriculturalLevel.Text)
            Province(SelectedArea).Farmland = CInt(Me.txtFarmland.Text)
            Province(SelectedArea).HarvestActual = CInt(Me.txtHarvestActual.Text)
            Province(SelectedArea).Peasants = CInt(Me.txtPeasants.Text)
            Province(SelectedArea).SurplusPopulation = CInt(Me.txtSurplusPop.Text)
            Province(SelectedArea).Townspeople = CInt(Me.txtTownspeople.Text)
            Province(SelectedArea).Fortifications = CInt(Me.txtFortifications.Text)
            Province(SelectedArea).FormalAffiliation = CInt(Me.txtFormalAffilaition.Text)
            Province(SelectedArea).ControlLevel = CInt(Me.txtControlLevel.Text)
            Province(SelectedArea).AdminLevel = CInt(Me.txtAdminLevel.Text)
            Province(SelectedArea).TownCharters = CInt(Me.txtCharteredTowns.Text)
            Province(SelectedArea).TradeLevel = CInt(Me.txtTradeLevel.Text)
            Province(SelectedArea).NavalValue = CInt(Me.txtNavalValue.Text)
            RecordChanged = True
            TextboxChanged = False

        Catch
            MsgBox("Invalid Value in a Textbox (A Blank?)")
            Province(SelectedArea).Clergy = Cl
            Province(SelectedArea).Nobles = No
            Province(SelectedArea).Religion = Re
            Province(SelectedArea).Loyalty = Lo
            Province(SelectedArea).PoliticalAffiliation = Af
            Province(SelectedArea).Language = La
            Province(SelectedArea).SurplusPopulation = Su
            Province(SelectedArea).Peasants = Pe
            Province(SelectedArea).AgricultureLevel = Al
            Province(SelectedArea).HarvestActual = Hv
            Province(SelectedArea).Farmland = Fl
            Province(SelectedArea).Townspeople = Tp
            Province(SelectedArea).Fortifications = Fo
            Province(SelectedArea).FormalAffiliation = Fa
            Province(SelectedArea).ControlLevel = Cv
            Province(SelectedArea).AdminLevel = Ad
            Province(SelectedArea).TownCharters = Ct
            Province(SelectedArea).TradeLevel = TL
            Province(SelectedArea).NavalValue = NV
        End Try


    End Sub

    Private Sub btnRestoreData_Click(sender As System.Object, e As System.EventArgs) Handles btnRestoreData.Click
        Dim MsgboxResult As Microsoft.VisualBasic.MsgBoxResult

        If TextboxChanged = False Then
            MsgBox("No Information Updated; No reason to Restore")
            Exit Sub
        End If

        MsgboxResult = MsgBox("Abandon Inputs?", MsgBoxStyle.YesNo, "Failsafe")

        If MsgboxResult = vbYes Then

            PopulateProvinceDisplay(SelectedArea)
            ColorTextboxes(SelectedArea)
            TextboxChanged = False

            Me.Refresh()

        End If


    End Sub

    Private Sub txtNeighbor1_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtNeighbor1.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub cbxConnector1_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cbxConnector1.SelectedIndexChanged

    End Sub

    Private Sub txtLoyalty_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtLoyalty.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtReligion_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtReligion.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtClergy_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtClergy.TextChanged
        TextboxChanged = True
    End Sub

    Private Sub txtNobles_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtNobles.TextChanged
        TextboxChanged = True
    End Sub

    Private Sub txtLanguage_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtLanguage.TextChanged
        TextboxChanged = True
    End Sub

    Private Sub ColorTextboxes(ByVal ID As Integer)

        Me.txtLoyalty.BackColor = GetLoyaltyColor(Province(ID).Loyalty)
        Me.txtPoliticalAffiliation.BackColor = GetGovernmentColor(Province(ID).PoliticalAffiliation)
        Me.txtTopgraphy.BackColor = GetTerrainColor(Province(ID).Topography)
        Me.txtSocialState.BackColor = GetSocialStateColor(Province(ID).SocialState)
        Me.txtReligion.BackColor = GetReligionColor(Province(ID).Religion)
        Me.txtLanguage.BackColor = GetLanguageColor(Province(ID).Language)
        Me.txtFormalAffilaition.BackColor = GetGovernmentColor(Province(ID).FormalAffiliation)
        Me.txtControlLevel.BackColor = GetGovernmentColor(Province(ID).ControlLevel)

    End Sub

    Private Sub lblConnectors_Click(sender As System.Object, e As System.EventArgs) Handles lblConnectors.Click

    End Sub

    Private Sub txtProvinceName_TextChanged(sender As Object, e As System.EventArgs) Handles txtProvinceName.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtSocialState_TextChanged(sender As Object, e As System.EventArgs) Handles txtSocialState.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtTownspeople_TextChanged(sender As Object, e As System.EventArgs) Handles txtTownspeople.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtNeighborName4_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtNeighborName4.TextChanged

    End Sub

    Private Sub txtConnectorName1_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtConnectorName1.TextChanged

    End Sub

    Private Sub txtFormalAffilaition_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtFormalAffilaition.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtFortifications_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtFortifications.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtAutonomy_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtControlLevel.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtAdminLevel_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtAdminLevel.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtCharteredTowns_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtCharteredTowns.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtTaxBase_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtTaxBase.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub TextBox2_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtNavalValue.TextChanged
        TextboxChanged = True

    End Sub

    Private Sub txtTradeLeel_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtTradeLevel.TextChanged
        TextboxChanged = True

    End Sub
End Class
